/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "bsimbulkdefs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int bsimbulktrunc(GENmodel *inModel, CKTcircuit *ckt, double *timeStep)
{
  bsimbulkmodel *model = (bsimbulkmodel*)inModel;
  bsimbulkinstance *here;

#ifdef STEPDEBUG
    double debugtemp;
#endif /* STEPDEBUG */  
  
  for ( ; model != NULL; model = bsimbulknextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = bsimbulkinstances(model); here != NULL ; here = bsimbulknextInstance(here))
    {
#ifdef STEPDEBUG
            debugtemp = *timeStep;
#endif /* STEPDEBUG */   
 
            CKTterr(here->state_bi_di, ckt, timeStep);
            CKTterr(here->state_bi_si, ckt, timeStep);
            CKTterr(here->state_dbulk_di, ckt, timeStep);
            CKTterr(here->state_sbulk_si, ckt, timeStep);
            CKTterr(here->state_t_GND, ckt, timeStep);
            CKTterr(here->state_gm_bi, ckt, timeStep);
            CKTterr(here->state_gm_di, ckt, timeStep);
            CKTterr(here->state_gm_si, ckt, timeStep);
            CKTterr(here->state_di_bi, ckt, timeStep);
            CKTterr(here->state_si_bi, ckt, timeStep);
            CKTterr(here->state_gi_bi, ckt, timeStep);
            CKTterr(here->state_gi_di, ckt, timeStep);
            CKTterr(here->state_gi_si, ckt, timeStep);
            CKTterr(here->state_N1_GND, ckt, timeStep);
    
 
#ifdef STEPDEBUG
            if(debugtemp != *timeStep)
	    {  printf("device %s reduces step from %g to %g\n",
                       here->bsimbulkname,debugtemp,*timeStep);
            }
#endif /* STEPDEBUG */
   
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
