/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "psp103defs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

int psp103setup (SMPmatrix *matrix, GENmodel *inModel, CKTcircuit *ckt, int *states)
     /* load the psp103 device structure with those pointers needed later 
      * for fast matrix loading 
      */
{
  psp103model *model = (psp103model*)inModel;
  psp103instance *here;
  
  /*  loop through all the psp103 device models */
  for ( ;model != NULL ;model = psp103nextModel(model) )
  {
    if(model->LEVEL_Given == FALSE) model->LEVEL=103;
    if(model->TYPE_Given == FALSE) model->TYPE=1;
    if(model->nmos_Given == FALSE) model->nmos=1;
    if(model->pmos_Given == FALSE) model->pmos=1;
    if(model->TR_Given == FALSE) model->TR=21.0;
    if(model->SWGEO_Given == FALSE) model->SWGEO=1;
    if(model->SWIGATE_Given == FALSE) model->SWIGATE=0;
    if(model->SWIMPACT_Given == FALSE) model->SWIMPACT=0;
    if(model->SWGIDL_Given == FALSE) model->SWGIDL=0;
    if(model->SWJUNCAP_Given == FALSE) model->SWJUNCAP=0;
    if(model->SWJUNASYM_Given == FALSE) model->SWJUNASYM=0;
    if(model->SWNUD_Given == FALSE) model->SWNUD=0;
    if(model->SWEDGE_Given == FALSE) model->SWEDGE=0;
    if(model->SWDELVTAC_Given == FALSE) model->SWDELVTAC=0;
    if(model->SWQSAT_Given == FALSE) model->SWQSAT=0;
    if(model->SWQPART_Given == FALSE) model->SWQPART=0;
    if(model->SWIGN_Given == FALSE) model->SWIGN=1;
    if(model->QMC_Given == FALSE) model->QMC=1.0;
    if(model->VFB_Given == FALSE) model->VFB=(-1.0);
    if(model->STVFB_Given == FALSE) model->STVFB=5.0e-4;
    if(model->ST2VFB_Given == FALSE) model->ST2VFB=0.0;
    if(model->TOX_Given == FALSE) model->TOX=2.0e-09;
    if(model->EPSROX_Given == FALSE) model->EPSROX=3.9;
    if(model->NEFF_Given == FALSE) model->NEFF=5.0e23;
    if(model->FACNEFFAC_Given == FALSE) model->FACNEFFAC=1.0;
    if(model->GFACNUD_Given == FALSE) model->GFACNUD=1.0;
    if(model->VSBNUD_Given == FALSE) model->VSBNUD=0.0;
    if(model->DVSBNUD_Given == FALSE) model->DVSBNUD=1.0;
    if(model->VNSUB_Given == FALSE) model->VNSUB=0.0;
    if(model->NSLP_Given == FALSE) model->NSLP=0.05;
    if(model->DNSUB_Given == FALSE) model->DNSUB=0.0;
    if(model->DPHIB_Given == FALSE) model->DPHIB=0.0;
    if(model->DELVTAC_Given == FALSE) model->DELVTAC=0.0;
    if(model->NP_Given == FALSE) model->NP=1.0e26;
    if(model->TOXOV_Given == FALSE) model->TOXOV=2.0e-09;
    if(model->TOXOVD_Given == FALSE) model->TOXOVD=2.0e-09;
    if(model->NOV_Given == FALSE) model->NOV=5.0e25;
    if(model->NOVD_Given == FALSE) model->NOVD=5.0e25;
    if(model->CT_Given == FALSE) model->CT=0.0;
    if(model->CTG_Given == FALSE) model->CTG=0.0;
    if(model->CTB_Given == FALSE) model->CTB=0.0;
    if(model->STCT_Given == FALSE) model->STCT=1.0;
    if(model->CF_Given == FALSE) model->CF=0.0;
    if(model->CFAC_Given == FALSE) model->CFAC=0.0;
    if(model->CFD_Given == FALSE) model->CFD=0.0;
    if(model->CFB_Given == FALSE) model->CFB=0.0;
    if(model->PSCE_Given == FALSE) model->PSCE=0.0;
    if(model->PSCEB_Given == FALSE) model->PSCEB=0.0;
    if(model->PSCED_Given == FALSE) model->PSCED=0.0;
    if(model->BETN_Given == FALSE) model->BETN=7.0e-2;
    if(model->STBET_Given == FALSE) model->STBET=1.0;
    if(model->MUE_Given == FALSE) model->MUE=0.5;
    if(model->STMUE_Given == FALSE) model->STMUE=0.0;
    if(model->THEMU_Given == FALSE) model->THEMU=1.5;
    if(model->STTHEMU_Given == FALSE) model->STTHEMU=1.5;
    if(model->CS_Given == FALSE) model->CS=0.0;
    if(model->STCS_Given == FALSE) model->STCS=0.0;
    if(model->THECS_Given == FALSE) model->THECS=2.0;
    if(model->STTHECS_Given == FALSE) model->STTHECS=0.0;
    if(model->XCOR_Given == FALSE) model->XCOR=0.0;
    if(model->STXCOR_Given == FALSE) model->STXCOR=0.0;
    if(model->FETA_Given == FALSE) model->FETA=1.0;
    if(model->RS_Given == FALSE) model->RS=30.0;
    if(model->STRS_Given == FALSE) model->STRS=1.0;
    if(model->RSB_Given == FALSE) model->RSB=0.0;
    if(model->RSG_Given == FALSE) model->RSG=0.0;
    if(model->THESAT_Given == FALSE) model->THESAT=1.0;
    if(model->THESATAC_Given == FALSE) model->THESATAC=1.0;
    if(model->STTHESAT_Given == FALSE) model->STTHESAT=1.0;
    if(model->THESATB_Given == FALSE) model->THESATB=0.0;
    if(model->THESATG_Given == FALSE) model->THESATG=0.0;
    if(model->AX_Given == FALSE) model->AX=3.0;
    if(model->AXAC_Given == FALSE) model->AXAC=3.0;
    if(model->ALP_Given == FALSE) model->ALP=0.01;
    if(model->ALPAC_Given == FALSE) model->ALPAC=0.01;
    if(model->ALP1_Given == FALSE) model->ALP1=0.0;
    if(model->ALP2_Given == FALSE) model->ALP2=0.0;
    if(model->VP_Given == FALSE) model->VP=0.05;
    if(model->A1_Given == FALSE) model->A1=1.0;
    if(model->A2_Given == FALSE) model->A2=10.0;
    if(model->STA2_Given == FALSE) model->STA2=0.0;
    if(model->A3_Given == FALSE) model->A3=1.0;
    if(model->A4_Given == FALSE) model->A4=0.0;
    if(model->GCO_Given == FALSE) model->GCO=0.0;
    if(model->IGINV_Given == FALSE) model->IGINV=0.0;
    if(model->IGOV_Given == FALSE) model->IGOV=0.0;
    if(model->IGOVD_Given == FALSE) model->IGOVD=0.0;
    if(model->STIG_Given == FALSE) model->STIG=2.0;
    if(model->GC2_Given == FALSE) model->GC2=0.375;
    if(model->GC3_Given == FALSE) model->GC3=0.063;
    if(model->GC2OV_Given == FALSE) model->GC2OV=0.375;
    if(model->GC3OV_Given == FALSE) model->GC3OV=0.063;
    if(model->CHIB_Given == FALSE) model->CHIB=3.1;
    if(model->AGIDL_Given == FALSE) model->AGIDL=0.0;
    if(model->AGIDLD_Given == FALSE) model->AGIDLD=0.0;
    if(model->BGIDL_Given == FALSE) model->BGIDL=41.0;
    if(model->BGIDLD_Given == FALSE) model->BGIDLD=41.0;
    if(model->STBGIDL_Given == FALSE) model->STBGIDL=0.0;
    if(model->STBGIDLD_Given == FALSE) model->STBGIDLD=0.0;
    if(model->CGIDL_Given == FALSE) model->CGIDL=0.0;
    if(model->CGIDLD_Given == FALSE) model->CGIDLD=0.0;
    if(model->COX_Given == FALSE) model->COX=1.0e-14;
    if(model->CGOV_Given == FALSE) model->CGOV=1.0e-15;
    if(model->CGOVD_Given == FALSE) model->CGOVD=1.0e-15;
    if(model->CGBOV_Given == FALSE) model->CGBOV=0.0;
    if(model->CFR_Given == FALSE) model->CFR=0.0;
    if(model->CFRD_Given == FALSE) model->CFRD=0.0;
    if(model->FNT_Given == FALSE) model->FNT=1.0;
    if(model->FNTEXC_Given == FALSE) model->FNTEXC=0.0;
    if(model->NFA_Given == FALSE) model->NFA=8.0e22;
    if(model->NFB_Given == FALSE) model->NFB=3.0e07;
    if(model->NFC_Given == FALSE) model->NFC=0.0;
    if(model->EF_Given == FALSE) model->EF=1.0;
    if(model->VFBEDGE_Given == FALSE) model->VFBEDGE=(-1.0);
    if(model->STVFBEDGE_Given == FALSE) model->STVFBEDGE=5.0e-4;
    if(model->DPHIBEDGE_Given == FALSE) model->DPHIBEDGE=0.0;
    if(model->NEFFEDGE_Given == FALSE) model->NEFFEDGE=5.0e23;
    if(model->CTEDGE_Given == FALSE) model->CTEDGE=0.0;
    if(model->BETNEDGE_Given == FALSE) model->BETNEDGE=5.0e-4;
    if(model->STBETEDGE_Given == FALSE) model->STBETEDGE=1.0;
    if(model->PSCEEDGE_Given == FALSE) model->PSCEEDGE=0.0;
    if(model->PSCEBEDGE_Given == FALSE) model->PSCEBEDGE=0.0;
    if(model->PSCEDEDGE_Given == FALSE) model->PSCEDEDGE=0.0;
    if(model->CFEDGE_Given == FALSE) model->CFEDGE=0.0;
    if(model->CFDEDGE_Given == FALSE) model->CFDEDGE=0.0;
    if(model->CFBEDGE_Given == FALSE) model->CFBEDGE=0.0;
    if(model->FNTEDGE_Given == FALSE) model->FNTEDGE=1.0;
    if(model->NFAEDGE_Given == FALSE) model->NFAEDGE=8.0e22;
    if(model->NFBEDGE_Given == FALSE) model->NFBEDGE=3.0e07;
    if(model->NFCEDGE_Given == FALSE) model->NFCEDGE=0.0;
    if(model->EFEDGE_Given == FALSE) model->EFEDGE=1.0;
    if(model->RG_Given == FALSE) model->RG=0.0;
    if(model->RSE_Given == FALSE) model->RSE=0.0;
    if(model->RDE_Given == FALSE) model->RDE=0.0;
    if(model->RBULK_Given == FALSE) model->RBULK=0.0;
    if(model->RWELL_Given == FALSE) model->RWELL=0.0;
    if(model->RJUNS_Given == FALSE) model->RJUNS=0.0;
    if(model->RJUND_Given == FALSE) model->RJUND=0.0;
    if(model->LVARO_Given == FALSE) model->LVARO=0.0;
    if(model->LVARL_Given == FALSE) model->LVARL=0.0;
    if(model->LVARW_Given == FALSE) model->LVARW=0.0;
    if(model->LAP_Given == FALSE) model->LAP=0.0;
    if(model->WVARO_Given == FALSE) model->WVARO=0.0;
    if(model->WVARL_Given == FALSE) model->WVARL=0.0;
    if(model->WVARW_Given == FALSE) model->WVARW=0.0;
    if(model->WOT_Given == FALSE) model->WOT=0.0;
    if(model->DLQ_Given == FALSE) model->DLQ=0.0;
    if(model->DWQ_Given == FALSE) model->DWQ=0.0;
    if(model->VFBO_Given == FALSE) model->VFBO=(-1.0);
    if(model->VFBL_Given == FALSE) model->VFBL=0.0;
    if(model->VFBW_Given == FALSE) model->VFBW=0.0;
    if(model->VFBLW_Given == FALSE) model->VFBLW=0.0;
    if(model->STVFBO_Given == FALSE) model->STVFBO=5.0e-4;
    if(model->STVFBL_Given == FALSE) model->STVFBL=0.0;
    if(model->STVFBW_Given == FALSE) model->STVFBW=0.0;
    if(model->STVFBLW_Given == FALSE) model->STVFBLW=0.0;
    if(model->ST2VFBO_Given == FALSE) model->ST2VFBO=0.0;
    if(model->TOXO_Given == FALSE) model->TOXO=2.0e-9;
    if(model->EPSROXO_Given == FALSE) model->EPSROXO=3.9;
    if(model->NSUBO_Given == FALSE) model->NSUBO=3.0e23;
    if(model->NSUBW_Given == FALSE) model->NSUBW=0.0;
    if(model->WSEG_Given == FALSE) model->WSEG=1.0e-8;
    if(model->NPCK_Given == FALSE) model->NPCK=1.0e24;
    if(model->NPCKW_Given == FALSE) model->NPCKW=0.0;
    if(model->WSEGP_Given == FALSE) model->WSEGP=1.0e-8;
    if(model->LPCK_Given == FALSE) model->LPCK=1.0e-8;
    if(model->LPCKW_Given == FALSE) model->LPCKW=0.0;
    if(model->FOL1_Given == FALSE) model->FOL1=0.0;
    if(model->FOL2_Given == FALSE) model->FOL2=0.0;
    if(model->FACNEFFACO_Given == FALSE) model->FACNEFFACO=1.0;
    if(model->FACNEFFACL_Given == FALSE) model->FACNEFFACL=0.0;
    if(model->FACNEFFACW_Given == FALSE) model->FACNEFFACW=0.0;
    if(model->FACNEFFACLW_Given == FALSE) model->FACNEFFACLW=0.0;
    if(model->GFACNUDO_Given == FALSE) model->GFACNUDO=1.0;
    if(model->GFACNUDL_Given == FALSE) model->GFACNUDL=0.0;
    if(model->GFACNUDLEXP_Given == FALSE) model->GFACNUDLEXP=1.0;
    if(model->GFACNUDW_Given == FALSE) model->GFACNUDW=0.0;
    if(model->GFACNUDLW_Given == FALSE) model->GFACNUDLW=0.0;
    if(model->VSBNUDO_Given == FALSE) model->VSBNUDO=0.0;
    if(model->DVSBNUDO_Given == FALSE) model->DVSBNUDO=1.0;
    if(model->VNSUBO_Given == FALSE) model->VNSUBO=0.0;
    if(model->NSLPO_Given == FALSE) model->NSLPO=0.05;
    if(model->DNSUBO_Given == FALSE) model->DNSUBO=0.0;
    if(model->DPHIBO_Given == FALSE) model->DPHIBO=0.0;
    if(model->DPHIBL_Given == FALSE) model->DPHIBL=0.0;
    if(model->DPHIBLEXP_Given == FALSE) model->DPHIBLEXP=1.0;
    if(model->DPHIBW_Given == FALSE) model->DPHIBW=0.0;
    if(model->DPHIBLW_Given == FALSE) model->DPHIBLW=0.0;
    if(model->DELVTACO_Given == FALSE) model->DELVTACO=0.0;
    if(model->DELVTACL_Given == FALSE) model->DELVTACL=0.0;
    if(model->DELVTACLEXP_Given == FALSE) model->DELVTACLEXP=1.0;
    if(model->DELVTACW_Given == FALSE) model->DELVTACW=0.0;
    if(model->DELVTACLW_Given == FALSE) model->DELVTACLW=0.0;
    if(model->NPO_Given == FALSE) model->NPO=1.0e26;
    if(model->NPL_Given == FALSE) model->NPL=0.0;
    if(model->TOXOVO_Given == FALSE) model->TOXOVO=2.0e-9;
    if(model->TOXOVDO_Given == FALSE) model->TOXOVDO=2.0e-9;
    if(model->LOV_Given == FALSE) model->LOV=0.0;
    if(model->LOVD_Given == FALSE) model->LOVD=0.0;
    if(model->NOVO_Given == FALSE) model->NOVO=5.0e25;
    if(model->NOVDO_Given == FALSE) model->NOVDO=5.0e25;
    if(model->CTO_Given == FALSE) model->CTO=0.0;
    if(model->CTL_Given == FALSE) model->CTL=0.0;
    if(model->CTLEXP_Given == FALSE) model->CTLEXP=1.0;
    if(model->CTW_Given == FALSE) model->CTW=0.0;
    if(model->CTLW_Given == FALSE) model->CTLW=0.0;
    if(model->CTGO_Given == FALSE) model->CTGO=0.0;
    if(model->CTBO_Given == FALSE) model->CTBO=0.0;
    if(model->STCTO_Given == FALSE) model->STCTO=1.0;
    if(model->CFL_Given == FALSE) model->CFL=0.0;
    if(model->CFLEXP_Given == FALSE) model->CFLEXP=2.0;
    if(model->CFW_Given == FALSE) model->CFW=0.0;
    if(model->CFACL_Given == FALSE) model->CFACL=0.0;
    if(model->CFACLEXP_Given == FALSE) model->CFACLEXP=2.0;
    if(model->CFACW_Given == FALSE) model->CFACW=0.0;
    if(model->CFDO_Given == FALSE) model->CFDO=0.0;
    if(model->CFBO_Given == FALSE) model->CFBO=0.0;
    if(model->PSCEL_Given == FALSE) model->PSCEL=0.0;
    if(model->PSCELEXP_Given == FALSE) model->PSCELEXP=2.0;
    if(model->PSCEW_Given == FALSE) model->PSCEW=0.0;
    if(model->PSCEBO_Given == FALSE) model->PSCEBO=0.0;
    if(model->PSCEDO_Given == FALSE) model->PSCEDO=0.0;
    if(model->UO_Given == FALSE) model->UO=5.0e-2;
    if(model->FBET1_Given == FALSE) model->FBET1=0.0;
    if(model->FBET1W_Given == FALSE) model->FBET1W=0.0;
    if(model->LP1_Given == FALSE) model->LP1=1.0e-8;
    if(model->LP1W_Given == FALSE) model->LP1W=0.0;
    if(model->FBET2_Given == FALSE) model->FBET2=0.0;
    if(model->LP2_Given == FALSE) model->LP2=1.0e-8;
    if(model->BETW1_Given == FALSE) model->BETW1=0.0;
    if(model->BETW2_Given == FALSE) model->BETW2=0.0;
    if(model->WBET_Given == FALSE) model->WBET=1.0e-9;
    if(model->STBETO_Given == FALSE) model->STBETO=1.0;
    if(model->STBETL_Given == FALSE) model->STBETL=0.0;
    if(model->STBETW_Given == FALSE) model->STBETW=0.0;
    if(model->STBETLW_Given == FALSE) model->STBETLW=0.0;
    if(model->MUEO_Given == FALSE) model->MUEO=0.5;
    if(model->MUEW_Given == FALSE) model->MUEW=0.0;
    if(model->STMUEO_Given == FALSE) model->STMUEO=0.0;
    if(model->THEMUO_Given == FALSE) model->THEMUO=1.5;
    if(model->STTHEMUO_Given == FALSE) model->STTHEMUO=1.5;
    if(model->CSO_Given == FALSE) model->CSO=0.0;
    if(model->CSL_Given == FALSE) model->CSL=0.0;
    if(model->CSLEXP_Given == FALSE) model->CSLEXP=1.0;
    if(model->CSW_Given == FALSE) model->CSW=0.0;
    if(model->CSLW_Given == FALSE) model->CSLW=0.0;
    if(model->STCSO_Given == FALSE) model->STCSO=0.0;
    if(model->THECSO_Given == FALSE) model->THECSO=2.0;
    if(model->STTHECSO_Given == FALSE) model->STTHECSO=0.0;
    if(model->XCORO_Given == FALSE) model->XCORO=0.0;
    if(model->XCORL_Given == FALSE) model->XCORL=0.0;
    if(model->XCORW_Given == FALSE) model->XCORW=0.0;
    if(model->XCORLW_Given == FALSE) model->XCORLW=0.0;
    if(model->STXCORO_Given == FALSE) model->STXCORO=0.0;
    if(model->FETAO_Given == FALSE) model->FETAO=1.0;
    if(model->RSW1_Given == FALSE) model->RSW1=50.0;
    if(model->RSW2_Given == FALSE) model->RSW2=0.0;
    if(model->STRSO_Given == FALSE) model->STRSO=1.0;
    if(model->RSBO_Given == FALSE) model->RSBO=0.0;
    if(model->RSGO_Given == FALSE) model->RSGO=0.0;
    if(model->THESATO_Given == FALSE) model->THESATO=0.0;
    if(model->THESATL_Given == FALSE) model->THESATL=0.05;
    if(model->THESATLEXP_Given == FALSE) model->THESATLEXP=1.0;
    if(model->THESATW_Given == FALSE) model->THESATW=0.0;
    if(model->THESATLW_Given == FALSE) model->THESATLW=0.0;
    if(model->THESATACO_Given == FALSE) model->THESATACO=0.0;
    if(model->THESATACL_Given == FALSE) model->THESATACL=0.05;
    if(model->THESATACLEXP_Given == FALSE) model->THESATACLEXP=1.0;
    if(model->THESATACW_Given == FALSE) model->THESATACW=0.0;
    if(model->THESATACLW_Given == FALSE) model->THESATACLW=0.0;
    if(model->STTHESATO_Given == FALSE) model->STTHESATO=1.0;
    if(model->STTHESATL_Given == FALSE) model->STTHESATL=0.0;
    if(model->STTHESATW_Given == FALSE) model->STTHESATW=0.0;
    if(model->STTHESATLW_Given == FALSE) model->STTHESATLW=0.0;
    if(model->THESATBO_Given == FALSE) model->THESATBO=0.0;
    if(model->THESATGO_Given == FALSE) model->THESATGO=0.0;
    if(model->AXO_Given == FALSE) model->AXO=18.0;
    if(model->AXL_Given == FALSE) model->AXL=0.4;
    if(model->AXACO_Given == FALSE) model->AXACO=18.0;
    if(model->AXACL_Given == FALSE) model->AXACL=0.4;
    if(model->ALPL_Given == FALSE) model->ALPL=5.0e-4;
    if(model->ALPLEXP_Given == FALSE) model->ALPLEXP=1.0;
    if(model->ALPW_Given == FALSE) model->ALPW=0.0;
    if(model->ALPACL_Given == FALSE) model->ALPACL=5.0e-4;
    if(model->ALPACLEXP_Given == FALSE) model->ALPACLEXP=1.0;
    if(model->ALPACW_Given == FALSE) model->ALPACW=0.0;
    if(model->ALP1L1_Given == FALSE) model->ALP1L1=0.0;
    if(model->ALP1LEXP_Given == FALSE) model->ALP1LEXP=0.5;
    if(model->ALP1L2_Given == FALSE) model->ALP1L2=0.0;
    if(model->ALP1W_Given == FALSE) model->ALP1W=0.0;
    if(model->ALP2L1_Given == FALSE) model->ALP2L1=0.0;
    if(model->ALP2LEXP_Given == FALSE) model->ALP2LEXP=0.5;
    if(model->ALP2L2_Given == FALSE) model->ALP2L2=0.0;
    if(model->ALP2W_Given == FALSE) model->ALP2W=0.0;
    if(model->VPO_Given == FALSE) model->VPO=0.05;
    if(model->A1O_Given == FALSE) model->A1O=1.0;
    if(model->A1L_Given == FALSE) model->A1L=0.0;
    if(model->A1W_Given == FALSE) model->A1W=0.0;
    if(model->A2O_Given == FALSE) model->A2O=10.0;
    if(model->STA2O_Given == FALSE) model->STA2O=0.0;
    if(model->A3O_Given == FALSE) model->A3O=1.0;
    if(model->A3L_Given == FALSE) model->A3L=0.0;
    if(model->A3W_Given == FALSE) model->A3W=0.0;
    if(model->A4O_Given == FALSE) model->A4O=0.0;
    if(model->A4L_Given == FALSE) model->A4L=0.0;
    if(model->A4W_Given == FALSE) model->A4W=0.0;
    if(model->GCOO_Given == FALSE) model->GCOO=0.0;
    if(model->IGINVLW_Given == FALSE) model->IGINVLW=0.0;
    if(model->IGOVW_Given == FALSE) model->IGOVW=0.0;
    if(model->IGOVDW_Given == FALSE) model->IGOVDW=0.0;
    if(model->STIGO_Given == FALSE) model->STIGO=2.0;
    if(model->GC2O_Given == FALSE) model->GC2O=0.375;
    if(model->GC3O_Given == FALSE) model->GC3O=0.063;
    if(model->GC2OVO_Given == FALSE) model->GC2OVO=0.375;
    if(model->GC3OVO_Given == FALSE) model->GC3OVO=0.063;
    if(model->CHIBO_Given == FALSE) model->CHIBO=3.1;
    if(model->AGIDLW_Given == FALSE) model->AGIDLW=0.0;
    if(model->AGIDLDW_Given == FALSE) model->AGIDLDW=0.0;
    if(model->BGIDLO_Given == FALSE) model->BGIDLO=41.0;
    if(model->BGIDLDO_Given == FALSE) model->BGIDLDO=41.0;
    if(model->STBGIDLO_Given == FALSE) model->STBGIDLO=0.0;
    if(model->STBGIDLDO_Given == FALSE) model->STBGIDLDO=0.0;
    if(model->CGIDLO_Given == FALSE) model->CGIDLO=0.0;
    if(model->CGIDLDO_Given == FALSE) model->CGIDLDO=0.0;
    if(model->CGBOVL_Given == FALSE) model->CGBOVL=0.0;
    if(model->CFRW_Given == FALSE) model->CFRW=0.0;
    if(model->CFRDW_Given == FALSE) model->CFRDW=0.0;
    if(model->FNTO_Given == FALSE) model->FNTO=1.0;
    if(model->FNTEXCL_Given == FALSE) model->FNTEXCL=0.0;
    if(model->NFALW_Given == FALSE) model->NFALW=8.0e22;
    if(model->NFBLW_Given == FALSE) model->NFBLW=3.0e7;
    if(model->NFCLW_Given == FALSE) model->NFCLW=0.0;
    if(model->EFO_Given == FALSE) model->EFO=1.0;
    if(model->LINTNOI_Given == FALSE) model->LINTNOI=0.0;
    if(model->ALPNOI_Given == FALSE) model->ALPNOI=2.0;
    if(model->WEDGE_Given == FALSE) model->WEDGE=1.0e-8;
    if(model->WEDGEW_Given == FALSE) model->WEDGEW=0.0;
    if(model->VFBEDGEO_Given == FALSE) model->VFBEDGEO=(-1.0);
    if(model->STVFBEDGEO_Given == FALSE) model->STVFBEDGEO=5.0e-4;
    if(model->STVFBEDGEL_Given == FALSE) model->STVFBEDGEL=0.0;
    if(model->STVFBEDGEW_Given == FALSE) model->STVFBEDGEW=0.0;
    if(model->STVFBEDGELW_Given == FALSE) model->STVFBEDGELW=0.0;
    if(model->DPHIBEDGEO_Given == FALSE) model->DPHIBEDGEO=0.0;
    if(model->DPHIBEDGEL_Given == FALSE) model->DPHIBEDGEL=0.0;
    if(model->DPHIBEDGELEXP_Given == FALSE) model->DPHIBEDGELEXP=1.0;
    if(model->DPHIBEDGEW_Given == FALSE) model->DPHIBEDGEW=0.0;
    if(model->DPHIBEDGELW_Given == FALSE) model->DPHIBEDGELW=0.0;
    if(model->NSUBEDGEO_Given == FALSE) model->NSUBEDGEO=5.0e23;
    if(model->NSUBEDGEL_Given == FALSE) model->NSUBEDGEL=0.0;
    if(model->NSUBEDGELEXP_Given == FALSE) model->NSUBEDGELEXP=1.0;
    if(model->NSUBEDGEW_Given == FALSE) model->NSUBEDGEW=0.0;
    if(model->NSUBEDGELW_Given == FALSE) model->NSUBEDGELW=0.0;
    if(model->CTEDGEO_Given == FALSE) model->CTEDGEO=0.0;
    if(model->CTEDGEL_Given == FALSE) model->CTEDGEL=0.0;
    if(model->CTEDGELEXP_Given == FALSE) model->CTEDGELEXP=1.0;
    if(model->FBETEDGE_Given == FALSE) model->FBETEDGE=0.0;
    if(model->LPEDGE_Given == FALSE) model->LPEDGE=1.0e-8;
    if(model->BETEDGEW_Given == FALSE) model->BETEDGEW=0.0;
    if(model->STBETEDGEO_Given == FALSE) model->STBETEDGEO=1.0;
    if(model->STBETEDGEL_Given == FALSE) model->STBETEDGEL=0.0;
    if(model->STBETEDGEW_Given == FALSE) model->STBETEDGEW=0.0;
    if(model->STBETEDGELW_Given == FALSE) model->STBETEDGELW=0.0;
    if(model->PSCEEDGEL_Given == FALSE) model->PSCEEDGEL=0.0;
    if(model->PSCEEDGELEXP_Given == FALSE) model->PSCEEDGELEXP=2.0;
    if(model->PSCEEDGEW_Given == FALSE) model->PSCEEDGEW=0.0;
    if(model->PSCEBEDGEO_Given == FALSE) model->PSCEBEDGEO=0.0;
    if(model->PSCEDEDGEO_Given == FALSE) model->PSCEDEDGEO=0.0;
    if(model->CFEDGEL_Given == FALSE) model->CFEDGEL=0.0;
    if(model->CFEDGELEXP_Given == FALSE) model->CFEDGELEXP=2.0;
    if(model->CFEDGEW_Given == FALSE) model->CFEDGEW=0.0;
    if(model->CFDEDGEO_Given == FALSE) model->CFDEDGEO=0.0;
    if(model->CFBEDGEO_Given == FALSE) model->CFBEDGEO=0.0;
    if(model->FNTEDGEO_Given == FALSE) model->FNTEDGEO=1.0;
    if(model->NFAEDGELW_Given == FALSE) model->NFAEDGELW=8.0e22;
    if(model->NFBEDGELW_Given == FALSE) model->NFBEDGELW=3.0e7;
    if(model->NFCEDGELW_Given == FALSE) model->NFCEDGELW=0.0;
    if(model->EFEDGEO_Given == FALSE) model->EFEDGEO=1.0;
    if(model->KVTHOWEO_Given == FALSE) model->KVTHOWEO=0.0;
    if(model->KVTHOWEL_Given == FALSE) model->KVTHOWEL=0.0;
    if(model->KVTHOWEW_Given == FALSE) model->KVTHOWEW=0.0;
    if(model->KVTHOWELW_Given == FALSE) model->KVTHOWELW=0.0;
    if(model->KUOWEO_Given == FALSE) model->KUOWEO=0.0;
    if(model->KUOWEL_Given == FALSE) model->KUOWEL=0.0;
    if(model->KUOWEW_Given == FALSE) model->KUOWEW=0.0;
    if(model->KUOWELW_Given == FALSE) model->KUOWELW=0.0;
    if(model->POVFB_Given == FALSE) model->POVFB=(-1.0);
    if(model->PLVFB_Given == FALSE) model->PLVFB=0.0;
    if(model->PWVFB_Given == FALSE) model->PWVFB=0.0;
    if(model->PLWVFB_Given == FALSE) model->PLWVFB=0.0;
    if(model->POSTVFB_Given == FALSE) model->POSTVFB=5.0e-4;
    if(model->PLSTVFB_Given == FALSE) model->PLSTVFB=0.0;
    if(model->PWSTVFB_Given == FALSE) model->PWSTVFB=0.0;
    if(model->PLWSTVFB_Given == FALSE) model->PLWSTVFB=0.0;
    if(model->POST2VFB_Given == FALSE) model->POST2VFB=0.0;
    if(model->POTOX_Given == FALSE) model->POTOX=2.0e-9;
    if(model->POEPSROX_Given == FALSE) model->POEPSROX=3.9;
    if(model->PONEFF_Given == FALSE) model->PONEFF=5.0e23;
    if(model->PLNEFF_Given == FALSE) model->PLNEFF=0.0;
    if(model->PWNEFF_Given == FALSE) model->PWNEFF=0.0;
    if(model->PLWNEFF_Given == FALSE) model->PLWNEFF=0.0;
    if(model->POFACNEFFAC_Given == FALSE) model->POFACNEFFAC=1.0;
    if(model->PLFACNEFFAC_Given == FALSE) model->PLFACNEFFAC=0.0;
    if(model->PWFACNEFFAC_Given == FALSE) model->PWFACNEFFAC=0.0;
    if(model->PLWFACNEFFAC_Given == FALSE) model->PLWFACNEFFAC=0.0;
    if(model->POGFACNUD_Given == FALSE) model->POGFACNUD=1.0;
    if(model->PLGFACNUD_Given == FALSE) model->PLGFACNUD=0.0;
    if(model->PWGFACNUD_Given == FALSE) model->PWGFACNUD=0.0;
    if(model->PLWGFACNUD_Given == FALSE) model->PLWGFACNUD=0.0;
    if(model->POVSBNUD_Given == FALSE) model->POVSBNUD=0.0;
    if(model->PODVSBNUD_Given == FALSE) model->PODVSBNUD=1.0;
    if(model->POVNSUB_Given == FALSE) model->POVNSUB=0.0;
    if(model->PONSLP_Given == FALSE) model->PONSLP=0.05;
    if(model->PODNSUB_Given == FALSE) model->PODNSUB=0.0;
    if(model->PODPHIB_Given == FALSE) model->PODPHIB=0.0;
    if(model->PLDPHIB_Given == FALSE) model->PLDPHIB=0.0;
    if(model->PWDPHIB_Given == FALSE) model->PWDPHIB=0.0;
    if(model->PLWDPHIB_Given == FALSE) model->PLWDPHIB=0.0;
    if(model->PODELVTAC_Given == FALSE) model->PODELVTAC=0.0;
    if(model->PLDELVTAC_Given == FALSE) model->PLDELVTAC=0.0;
    if(model->PWDELVTAC_Given == FALSE) model->PWDELVTAC=0.0;
    if(model->PLWDELVTAC_Given == FALSE) model->PLWDELVTAC=0.0;
    if(model->PONP_Given == FALSE) model->PONP=1.0e26;
    if(model->PLNP_Given == FALSE) model->PLNP=0.0;
    if(model->PWNP_Given == FALSE) model->PWNP=0.0;
    if(model->PLWNP_Given == FALSE) model->PLWNP=0.0;
    if(model->POTOXOV_Given == FALSE) model->POTOXOV=2.0e-09;
    if(model->POTOXOVD_Given == FALSE) model->POTOXOVD=2.0e-09;
    if(model->PONOV_Given == FALSE) model->PONOV=5.0e25;
    if(model->PLNOV_Given == FALSE) model->PLNOV=0.0;
    if(model->PWNOV_Given == FALSE) model->PWNOV=0.0;
    if(model->PLWNOV_Given == FALSE) model->PLWNOV=0.0;
    if(model->PONOVD_Given == FALSE) model->PONOVD=5.0e25;
    if(model->PLNOVD_Given == FALSE) model->PLNOVD=0.0;
    if(model->PWNOVD_Given == FALSE) model->PWNOVD=0.0;
    if(model->PLWNOVD_Given == FALSE) model->PLWNOVD=0.0;
    if(model->POCT_Given == FALSE) model->POCT=0.0;
    if(model->PLCT_Given == FALSE) model->PLCT=0.0;
    if(model->PWCT_Given == FALSE) model->PWCT=0.0;
    if(model->PLWCT_Given == FALSE) model->PLWCT=0.0;
    if(model->POCTG_Given == FALSE) model->POCTG=0.0;
    if(model->POCTB_Given == FALSE) model->POCTB=0.0;
    if(model->POSTCT_Given == FALSE) model->POSTCT=1.0;
    if(model->POCF_Given == FALSE) model->POCF=0.0;
    if(model->PLCF_Given == FALSE) model->PLCF=0.0;
    if(model->PWCF_Given == FALSE) model->PWCF=0.0;
    if(model->PLWCF_Given == FALSE) model->PLWCF=0.0;
    if(model->POCFAC_Given == FALSE) model->POCFAC=0.0;
    if(model->PLCFAC_Given == FALSE) model->PLCFAC=0.0;
    if(model->PWCFAC_Given == FALSE) model->PWCFAC=0.0;
    if(model->PLWCFAC_Given == FALSE) model->PLWCFAC=0.0;
    if(model->POCFD_Given == FALSE) model->POCFD=0.0;
    if(model->POCFB_Given == FALSE) model->POCFB=0.0;
    if(model->POPSCE_Given == FALSE) model->POPSCE=0.0;
    if(model->PLPSCE_Given == FALSE) model->PLPSCE=0.0;
    if(model->PWPSCE_Given == FALSE) model->PWPSCE=0.0;
    if(model->PLWPSCE_Given == FALSE) model->PLWPSCE=0.0;
    if(model->POPSCEB_Given == FALSE) model->POPSCEB=0.0;
    if(model->POPSCED_Given == FALSE) model->POPSCED=0.0;
    if(model->POBETN_Given == FALSE) model->POBETN=7.0e-2;
    if(model->PLBETN_Given == FALSE) model->PLBETN=0.0;
    if(model->PWBETN_Given == FALSE) model->PWBETN=0.0;
    if(model->PLWBETN_Given == FALSE) model->PLWBETN=0.0;
    if(model->POSTBET_Given == FALSE) model->POSTBET=1.0;
    if(model->PLSTBET_Given == FALSE) model->PLSTBET=0.0;
    if(model->PWSTBET_Given == FALSE) model->PWSTBET=0.0;
    if(model->PLWSTBET_Given == FALSE) model->PLWSTBET=0.0;
    if(model->POMUE_Given == FALSE) model->POMUE=0.5;
    if(model->PLMUE_Given == FALSE) model->PLMUE=0.0;
    if(model->PWMUE_Given == FALSE) model->PWMUE=0.0;
    if(model->PLWMUE_Given == FALSE) model->PLWMUE=0.0;
    if(model->POSTMUE_Given == FALSE) model->POSTMUE=0.0;
    if(model->POTHEMU_Given == FALSE) model->POTHEMU=1.5;
    if(model->POSTTHEMU_Given == FALSE) model->POSTTHEMU=1.5;
    if(model->POCS_Given == FALSE) model->POCS=0.0;
    if(model->PLCS_Given == FALSE) model->PLCS=0.0;
    if(model->PWCS_Given == FALSE) model->PWCS=0.0;
    if(model->PLWCS_Given == FALSE) model->PLWCS=0.0;
    if(model->POSTCS_Given == FALSE) model->POSTCS=0.0;
    if(model->POTHECS_Given == FALSE) model->POTHECS=2.0;
    if(model->POSTTHECS_Given == FALSE) model->POSTTHECS=0.0;
    if(model->POXCOR_Given == FALSE) model->POXCOR=0.0;
    if(model->PLXCOR_Given == FALSE) model->PLXCOR=0.0;
    if(model->PWXCOR_Given == FALSE) model->PWXCOR=0.0;
    if(model->PLWXCOR_Given == FALSE) model->PLWXCOR=0.0;
    if(model->POSTXCOR_Given == FALSE) model->POSTXCOR=0.0;
    if(model->POFETA_Given == FALSE) model->POFETA=1.0;
    if(model->PORS_Given == FALSE) model->PORS=30.0;
    if(model->PLRS_Given == FALSE) model->PLRS=0.0;
    if(model->PWRS_Given == FALSE) model->PWRS=0.0;
    if(model->PLWRS_Given == FALSE) model->PLWRS=0.0;
    if(model->POSTRS_Given == FALSE) model->POSTRS=1.0;
    if(model->PORSB_Given == FALSE) model->PORSB=0.0;
    if(model->PORSG_Given == FALSE) model->PORSG=0.0;
    if(model->POTHESAT_Given == FALSE) model->POTHESAT=1.0;
    if(model->PLTHESAT_Given == FALSE) model->PLTHESAT=0.0;
    if(model->PWTHESAT_Given == FALSE) model->PWTHESAT=0.0;
    if(model->PLWTHESAT_Given == FALSE) model->PLWTHESAT=0.0;
    if(model->POTHESATAC_Given == FALSE) model->POTHESATAC=1.0;
    if(model->PLTHESATAC_Given == FALSE) model->PLTHESATAC=0.0;
    if(model->PWTHESATAC_Given == FALSE) model->PWTHESATAC=0.0;
    if(model->PLWTHESATAC_Given == FALSE) model->PLWTHESATAC=0.0;
    if(model->POSTTHESAT_Given == FALSE) model->POSTTHESAT=1.0;
    if(model->PLSTTHESAT_Given == FALSE) model->PLSTTHESAT=0.0;
    if(model->PWSTTHESAT_Given == FALSE) model->PWSTTHESAT=0.0;
    if(model->PLWSTTHESAT_Given == FALSE) model->PLWSTTHESAT=0.0;
    if(model->POTHESATB_Given == FALSE) model->POTHESATB=0.0;
    if(model->PLTHESATB_Given == FALSE) model->PLTHESATB=0.0;
    if(model->PWTHESATB_Given == FALSE) model->PWTHESATB=0.0;
    if(model->PLWTHESATB_Given == FALSE) model->PLWTHESATB=0.0;
    if(model->POTHESATG_Given == FALSE) model->POTHESATG=0.0;
    if(model->PLTHESATG_Given == FALSE) model->PLTHESATG=0.0;
    if(model->PWTHESATG_Given == FALSE) model->PWTHESATG=0.0;
    if(model->PLWTHESATG_Given == FALSE) model->PLWTHESATG=0.0;
    if(model->POAX_Given == FALSE) model->POAX=3.0;
    if(model->PLAX_Given == FALSE) model->PLAX=0.0;
    if(model->PWAX_Given == FALSE) model->PWAX=0.0;
    if(model->PLWAX_Given == FALSE) model->PLWAX=0.0;
    if(model->POAXAC_Given == FALSE) model->POAXAC=3.0;
    if(model->PLAXAC_Given == FALSE) model->PLAXAC=0.0;
    if(model->PWAXAC_Given == FALSE) model->PWAXAC=0.0;
    if(model->PLWAXAC_Given == FALSE) model->PLWAXAC=0.0;
    if(model->POALP_Given == FALSE) model->POALP=1.0e-2;
    if(model->PLALP_Given == FALSE) model->PLALP=0.0;
    if(model->PWALP_Given == FALSE) model->PWALP=0.0;
    if(model->PLWALP_Given == FALSE) model->PLWALP=0.0;
    if(model->POALPAC_Given == FALSE) model->POALPAC=1.0e-2;
    if(model->PLALPAC_Given == FALSE) model->PLALPAC=0.0;
    if(model->PWALPAC_Given == FALSE) model->PWALPAC=0.0;
    if(model->PLWALPAC_Given == FALSE) model->PLWALPAC=0.0;
    if(model->POALP1_Given == FALSE) model->POALP1=0.0;
    if(model->PLALP1_Given == FALSE) model->PLALP1=0.0;
    if(model->PWALP1_Given == FALSE) model->PWALP1=0.0;
    if(model->PLWALP1_Given == FALSE) model->PLWALP1=0.0;
    if(model->POALP2_Given == FALSE) model->POALP2=0.0;
    if(model->PLALP2_Given == FALSE) model->PLALP2=0.0;
    if(model->PWALP2_Given == FALSE) model->PWALP2=0.0;
    if(model->PLWALP2_Given == FALSE) model->PLWALP2=0.0;
    if(model->POVP_Given == FALSE) model->POVP=0.05;
    if(model->POA1_Given == FALSE) model->POA1=1.0;
    if(model->PLA1_Given == FALSE) model->PLA1=0.0;
    if(model->PWA1_Given == FALSE) model->PWA1=0.0;
    if(model->PLWA1_Given == FALSE) model->PLWA1=0.0;
    if(model->POA2_Given == FALSE) model->POA2=10.0;
    if(model->POSTA2_Given == FALSE) model->POSTA2=0.0;
    if(model->POA3_Given == FALSE) model->POA3=1.0;
    if(model->PLA3_Given == FALSE) model->PLA3=0.0;
    if(model->PWA3_Given == FALSE) model->PWA3=0.0;
    if(model->PLWA3_Given == FALSE) model->PLWA3=0.0;
    if(model->POA4_Given == FALSE) model->POA4=0.0;
    if(model->PLA4_Given == FALSE) model->PLA4=0.0;
    if(model->PWA4_Given == FALSE) model->PWA4=0.0;
    if(model->PLWA4_Given == FALSE) model->PLWA4=0.0;
    if(model->POGCO_Given == FALSE) model->POGCO=0.0;
    if(model->POIGINV_Given == FALSE) model->POIGINV=0.0;
    if(model->PLIGINV_Given == FALSE) model->PLIGINV=0.0;
    if(model->PWIGINV_Given == FALSE) model->PWIGINV=0.0;
    if(model->PLWIGINV_Given == FALSE) model->PLWIGINV=0.0;
    if(model->POIGOV_Given == FALSE) model->POIGOV=0.0;
    if(model->PLIGOV_Given == FALSE) model->PLIGOV=0.0;
    if(model->PWIGOV_Given == FALSE) model->PWIGOV=0.0;
    if(model->PLWIGOV_Given == FALSE) model->PLWIGOV=0.0;
    if(model->POIGOVD_Given == FALSE) model->POIGOVD=0.0;
    if(model->PLIGOVD_Given == FALSE) model->PLIGOVD=0.0;
    if(model->PWIGOVD_Given == FALSE) model->PWIGOVD=0.0;
    if(model->PLWIGOVD_Given == FALSE) model->PLWIGOVD=0.0;
    if(model->POSTIG_Given == FALSE) model->POSTIG=2.0;
    if(model->POGC2_Given == FALSE) model->POGC2=0.375;
    if(model->POGC3_Given == FALSE) model->POGC3=0.063;
    if(model->POGC2OV_Given == FALSE) model->POGC2OV=0.375;
    if(model->POGC3OV_Given == FALSE) model->POGC3OV=0.063;
    if(model->POCHIB_Given == FALSE) model->POCHIB=3.1;
    if(model->POAGIDL_Given == FALSE) model->POAGIDL=0.0;
    if(model->PLAGIDL_Given == FALSE) model->PLAGIDL=0.0;
    if(model->PWAGIDL_Given == FALSE) model->PWAGIDL=0.0;
    if(model->PLWAGIDL_Given == FALSE) model->PLWAGIDL=0.0;
    if(model->POAGIDLD_Given == FALSE) model->POAGIDLD=0.0;
    if(model->PLAGIDLD_Given == FALSE) model->PLAGIDLD=0.0;
    if(model->PWAGIDLD_Given == FALSE) model->PWAGIDLD=0.0;
    if(model->PLWAGIDLD_Given == FALSE) model->PLWAGIDLD=0.0;
    if(model->POBGIDL_Given == FALSE) model->POBGIDL=41.0;
    if(model->POBGIDLD_Given == FALSE) model->POBGIDLD=41.0;
    if(model->POSTBGIDL_Given == FALSE) model->POSTBGIDL=0.0;
    if(model->POSTBGIDLD_Given == FALSE) model->POSTBGIDLD=0.0;
    if(model->POCGIDL_Given == FALSE) model->POCGIDL=0.0;
    if(model->POCGIDLD_Given == FALSE) model->POCGIDLD=0.0;
    if(model->POCOX_Given == FALSE) model->POCOX=1.0e-14;
    if(model->PLCOX_Given == FALSE) model->PLCOX=0.0;
    if(model->PWCOX_Given == FALSE) model->PWCOX=0.0;
    if(model->PLWCOX_Given == FALSE) model->PLWCOX=0.0;
    if(model->POCGOV_Given == FALSE) model->POCGOV=1.0e-15;
    if(model->PLCGOV_Given == FALSE) model->PLCGOV=0.0;
    if(model->PWCGOV_Given == FALSE) model->PWCGOV=0.0;
    if(model->PLWCGOV_Given == FALSE) model->PLWCGOV=0.0;
    if(model->POCGOVD_Given == FALSE) model->POCGOVD=1.0e-15;
    if(model->PLCGOVD_Given == FALSE) model->PLCGOVD=0.0;
    if(model->PWCGOVD_Given == FALSE) model->PWCGOVD=0.0;
    if(model->PLWCGOVD_Given == FALSE) model->PLWCGOVD=0.0;
    if(model->POCGBOV_Given == FALSE) model->POCGBOV=0.0;
    if(model->PLCGBOV_Given == FALSE) model->PLCGBOV=0.0;
    if(model->PWCGBOV_Given == FALSE) model->PWCGBOV=0.0;
    if(model->PLWCGBOV_Given == FALSE) model->PLWCGBOV=0.0;
    if(model->POCFR_Given == FALSE) model->POCFR=0.0;
    if(model->PLCFR_Given == FALSE) model->PLCFR=0.0;
    if(model->PWCFR_Given == FALSE) model->PWCFR=0.0;
    if(model->PLWCFR_Given == FALSE) model->PLWCFR=0.0;
    if(model->POCFRD_Given == FALSE) model->POCFRD=0.0;
    if(model->PLCFRD_Given == FALSE) model->PLCFRD=0.0;
    if(model->PWCFRD_Given == FALSE) model->PWCFRD=0.0;
    if(model->PLWCFRD_Given == FALSE) model->PLWCFRD=0.0;
    if(model->POFNT_Given == FALSE) model->POFNT=1.0;
    if(model->POFNTEXC_Given == FALSE) model->POFNTEXC=0.0;
    if(model->PLFNTEXC_Given == FALSE) model->PLFNTEXC=0.0;
    if(model->PWFNTEXC_Given == FALSE) model->PWFNTEXC=0.0;
    if(model->PLWFNTEXC_Given == FALSE) model->PLWFNTEXC=0.0;
    if(model->PONFA_Given == FALSE) model->PONFA=8.0e22;
    if(model->PLNFA_Given == FALSE) model->PLNFA=0.0;
    if(model->PWNFA_Given == FALSE) model->PWNFA=0.0;
    if(model->PLWNFA_Given == FALSE) model->PLWNFA=0.0;
    if(model->PONFB_Given == FALSE) model->PONFB=3.0e7;
    if(model->PLNFB_Given == FALSE) model->PLNFB=0.0;
    if(model->PWNFB_Given == FALSE) model->PWNFB=0.0;
    if(model->PLWNFB_Given == FALSE) model->PLWNFB=0.0;
    if(model->PONFC_Given == FALSE) model->PONFC=0.0;
    if(model->PLNFC_Given == FALSE) model->PLNFC=0.0;
    if(model->PWNFC_Given == FALSE) model->PWNFC=0.0;
    if(model->PLWNFC_Given == FALSE) model->PLWNFC=0.0;
    if(model->POEF_Given == FALSE) model->POEF=1.0;
    if(model->POVFBEDGE_Given == FALSE) model->POVFBEDGE=(-1.0);
    if(model->POSTVFBEDGE_Given == FALSE) model->POSTVFBEDGE=0.0;
    if(model->PLSTVFBEDGE_Given == FALSE) model->PLSTVFBEDGE=0.0;
    if(model->PWSTVFBEDGE_Given == FALSE) model->PWSTVFBEDGE=0.0;
    if(model->PLWSTVFBEDGE_Given == FALSE) model->PLWSTVFBEDGE=0.0;
    if(model->PODPHIBEDGE_Given == FALSE) model->PODPHIBEDGE=0.0;
    if(model->PLDPHIBEDGE_Given == FALSE) model->PLDPHIBEDGE=0.0;
    if(model->PWDPHIBEDGE_Given == FALSE) model->PWDPHIBEDGE=0.0;
    if(model->PLWDPHIBEDGE_Given == FALSE) model->PLWDPHIBEDGE=0.0;
    if(model->PONEFFEDGE_Given == FALSE) model->PONEFFEDGE=5.0e23;
    if(model->PLNEFFEDGE_Given == FALSE) model->PLNEFFEDGE=0.0;
    if(model->PWNEFFEDGE_Given == FALSE) model->PWNEFFEDGE=0.0;
    if(model->PLWNEFFEDGE_Given == FALSE) model->PLWNEFFEDGE=0.0;
    if(model->POCTEDGE_Given == FALSE) model->POCTEDGE=0.0;
    if(model->PLCTEDGE_Given == FALSE) model->PLCTEDGE=0.0;
    if(model->PWCTEDGE_Given == FALSE) model->PWCTEDGE=0.0;
    if(model->PLWCTEDGE_Given == FALSE) model->PLWCTEDGE=0.0;
    if(model->POBETNEDGE_Given == FALSE) model->POBETNEDGE=5.0e-4;
    if(model->PLBETNEDGE_Given == FALSE) model->PLBETNEDGE=0.0;
    if(model->PWBETNEDGE_Given == FALSE) model->PWBETNEDGE=0.0;
    if(model->PLWBETNEDGE_Given == FALSE) model->PLWBETNEDGE=0.0;
    if(model->POSTBETEDGE_Given == FALSE) model->POSTBETEDGE=1.0;
    if(model->PLSTBETEDGE_Given == FALSE) model->PLSTBETEDGE=0.0;
    if(model->PWSTBETEDGE_Given == FALSE) model->PWSTBETEDGE=0.0;
    if(model->PLWSTBETEDGE_Given == FALSE) model->PLWSTBETEDGE=0.0;
    if(model->POPSCEEDGE_Given == FALSE) model->POPSCEEDGE=0.0;
    if(model->PLPSCEEDGE_Given == FALSE) model->PLPSCEEDGE=0.0;
    if(model->PWPSCEEDGE_Given == FALSE) model->PWPSCEEDGE=0.0;
    if(model->PLWPSCEEDGE_Given == FALSE) model->PLWPSCEEDGE=0.0;
    if(model->POPSCEBEDGE_Given == FALSE) model->POPSCEBEDGE=0.0;
    if(model->POPSCEDEDGE_Given == FALSE) model->POPSCEDEDGE=0.0;
    if(model->POCFEDGE_Given == FALSE) model->POCFEDGE=0.0;
    if(model->PLCFEDGE_Given == FALSE) model->PLCFEDGE=0.0;
    if(model->PWCFEDGE_Given == FALSE) model->PWCFEDGE=0.0;
    if(model->PLWCFEDGE_Given == FALSE) model->PLWCFEDGE=0.0;
    if(model->POCFDEDGE_Given == FALSE) model->POCFDEDGE=0.0;
    if(model->POCFBEDGE_Given == FALSE) model->POCFBEDGE=0.0;
    if(model->POFNTEDGE_Given == FALSE) model->POFNTEDGE=1.0;
    if(model->PONFAEDGE_Given == FALSE) model->PONFAEDGE=8.0e22;
    if(model->PLNFAEDGE_Given == FALSE) model->PLNFAEDGE=0.0;
    if(model->PWNFAEDGE_Given == FALSE) model->PWNFAEDGE=0.0;
    if(model->PLWNFAEDGE_Given == FALSE) model->PLWNFAEDGE=0.0;
    if(model->PONFBEDGE_Given == FALSE) model->PONFBEDGE=3.0e7;
    if(model->PLNFBEDGE_Given == FALSE) model->PLNFBEDGE=0.0;
    if(model->PWNFBEDGE_Given == FALSE) model->PWNFBEDGE=0.0;
    if(model->PLWNFBEDGE_Given == FALSE) model->PLWNFBEDGE=0.0;
    if(model->PONFCEDGE_Given == FALSE) model->PONFCEDGE=0.0;
    if(model->PLNFCEDGE_Given == FALSE) model->PLNFCEDGE=0.0;
    if(model->PWNFCEDGE_Given == FALSE) model->PWNFCEDGE=0.0;
    if(model->PLWNFCEDGE_Given == FALSE) model->PLWNFCEDGE=0.0;
    if(model->POEFEDGE_Given == FALSE) model->POEFEDGE=1.0;
    if(model->POKVTHOWE_Given == FALSE) model->POKVTHOWE=0.0;
    if(model->PLKVTHOWE_Given == FALSE) model->PLKVTHOWE=0.0;
    if(model->PWKVTHOWE_Given == FALSE) model->PWKVTHOWE=0.0;
    if(model->PLWKVTHOWE_Given == FALSE) model->PLWKVTHOWE=0.0;
    if(model->POKUOWE_Given == FALSE) model->POKUOWE=0.0;
    if(model->PLKUOWE_Given == FALSE) model->PLKUOWE=0.0;
    if(model->PWKUOWE_Given == FALSE) model->PWKUOWE=0.0;
    if(model->PLWKUOWE_Given == FALSE) model->PLWKUOWE=0.0;
    if(model->LMIN_Given == FALSE) model->LMIN=0;
    if(model->LMAX_Given == FALSE) model->LMAX=1.0;
    if(model->WMIN_Given == FALSE) model->WMIN=0.0;
    if(model->WMAX_Given == FALSE) model->WMAX=1.0;
    if(model->RGO_Given == FALSE) model->RGO=0.0;
    if(model->RINT_Given == FALSE) model->RINT=0.0;
    if(model->RVPOLY_Given == FALSE) model->RVPOLY=0.0;
    if(model->RSHG_Given == FALSE) model->RSHG=0.0;
    if(model->DLSIL_Given == FALSE) model->DLSIL=0.0;
    if(model->RSH_Given == FALSE) model->RSH=0.0;
    if(model->RSHD_Given == FALSE) model->RSHD=0.0;
    if(model->RBULKO_Given == FALSE) model->RBULKO=0.0;
    if(model->RWELLO_Given == FALSE) model->RWELLO=0.0;
    if(model->RJUNSO_Given == FALSE) model->RJUNSO=0.0;
    if(model->RJUNDO_Given == FALSE) model->RJUNDO=0.0;
    if(model->SAREF_Given == FALSE) model->SAREF=1.0e-6;
    if(model->SBREF_Given == FALSE) model->SBREF=1.0e-6;
    if(model->WLOD_Given == FALSE) model->WLOD=0.0;
    if(model->KUO_Given == FALSE) model->KUO=0.0;
    if(model->KVSAT_Given == FALSE) model->KVSAT=0.0;
    if(model->KVSATAC_Given == FALSE) model->KVSATAC=0.0;
    if(model->TKUO_Given == FALSE) model->TKUO=0.0;
    if(model->LKUO_Given == FALSE) model->LKUO=0.0;
    if(model->WKUO_Given == FALSE) model->WKUO=0.0;
    if(model->PKUO_Given == FALSE) model->PKUO=0.0;
    if(model->LLODKUO_Given == FALSE) model->LLODKUO=0.0;
    if(model->WLODKUO_Given == FALSE) model->WLODKUO=0.0;
    if(model->KVTHO_Given == FALSE) model->KVTHO=0.0;
    if(model->LKVTHO_Given == FALSE) model->LKVTHO=0.0;
    if(model->WKVTHO_Given == FALSE) model->WKVTHO=0.0;
    if(model->PKVTHO_Given == FALSE) model->PKVTHO=0.0;
    if(model->LLODVTH_Given == FALSE) model->LLODVTH=0.0;
    if(model->WLODVTH_Given == FALSE) model->WLODVTH=0.0;
    if(model->STETAO_Given == FALSE) model->STETAO=0.0;
    if(model->LODETAO_Given == FALSE) model->LODETAO=1.0;
    if(model->SCREF_Given == FALSE) model->SCREF=1.0e-6;
    if(model->WEB_Given == FALSE) model->WEB=0.0;
    if(model->WEC_Given == FALSE) model->WEC=0.0;
    if(model->DTA_Given == FALSE) model->DTA=0.0;
    if(model->IMAX_Given == FALSE) model->IMAX=1000.0;
    if(model->TRJ_Given == FALSE) model->TRJ=21.0;
    if(model->FREV_Given == FALSE) model->FREV=1.0e3;
    if(model->CJORBOT_Given == FALSE) model->CJORBOT=1.0e-3;
    if(model->CJORSTI_Given == FALSE) model->CJORSTI=1.0e-9;
    if(model->CJORGAT_Given == FALSE) model->CJORGAT=1.0e-9;
    if(model->VBIRBOT_Given == FALSE) model->VBIRBOT=1.0;
    if(model->VBIRSTI_Given == FALSE) model->VBIRSTI=1.0;
    if(model->VBIRGAT_Given == FALSE) model->VBIRGAT=1.0;
    if(model->PBOT_Given == FALSE) model->PBOT=0.5;
    if(model->PSTI_Given == FALSE) model->PSTI=0.5;
    if(model->PGAT_Given == FALSE) model->PGAT=0.5;
    if(model->PHIGBOT_Given == FALSE) model->PHIGBOT=1.16;
    if(model->PHIGSTI_Given == FALSE) model->PHIGSTI=1.16;
    if(model->PHIGGAT_Given == FALSE) model->PHIGGAT=1.16;
    if(model->IDSATRBOT_Given == FALSE) model->IDSATRBOT=1.0e-12;
    if(model->IDSATRSTI_Given == FALSE) model->IDSATRSTI=1.0e-18;
    if(model->IDSATRGAT_Given == FALSE) model->IDSATRGAT=1.0e-18;
    if(model->CSRHBOT_Given == FALSE) model->CSRHBOT=1.0e2;
    if(model->CSRHSTI_Given == FALSE) model->CSRHSTI=1.0e-4;
    if(model->CSRHGAT_Given == FALSE) model->CSRHGAT=1.0e-4;
    if(model->XJUNSTI_Given == FALSE) model->XJUNSTI=1.0e-7;
    if(model->XJUNGAT_Given == FALSE) model->XJUNGAT=1.0e-7;
    if(model->CTATBOT_Given == FALSE) model->CTATBOT=1.0e2;
    if(model->CTATSTI_Given == FALSE) model->CTATSTI=1.0e-4;
    if(model->CTATGAT_Given == FALSE) model->CTATGAT=1.0e-4;
    if(model->MEFFTATBOT_Given == FALSE) model->MEFFTATBOT=0.25;
    if(model->MEFFTATSTI_Given == FALSE) model->MEFFTATSTI=0.25;
    if(model->MEFFTATGAT_Given == FALSE) model->MEFFTATGAT=0.25;
    if(model->CBBTBOT_Given == FALSE) model->CBBTBOT=1.0e-12;
    if(model->CBBTSTI_Given == FALSE) model->CBBTSTI=1.0e-18;
    if(model->CBBTGAT_Given == FALSE) model->CBBTGAT=1.0e-18;
    if(model->FBBTRBOT_Given == FALSE) model->FBBTRBOT=1.0e9;
    if(model->FBBTRSTI_Given == FALSE) model->FBBTRSTI=1.0e9;
    if(model->FBBTRGAT_Given == FALSE) model->FBBTRGAT=1.0e9;
    if(model->STFBBTBOT_Given == FALSE) model->STFBBTBOT=(-1.0e-3);
    if(model->STFBBTSTI_Given == FALSE) model->STFBBTSTI=(-1.0e-3);
    if(model->STFBBTGAT_Given == FALSE) model->STFBBTGAT=(-1.0e-3);
    if(model->VBRBOT_Given == FALSE) model->VBRBOT=10.0;
    if(model->VBRSTI_Given == FALSE) model->VBRSTI=10.0;
    if(model->VBRGAT_Given == FALSE) model->VBRGAT=10.0;
    if(model->PBRBOT_Given == FALSE) model->PBRBOT=4.0;
    if(model->PBRSTI_Given == FALSE) model->PBRSTI=4.0;
    if(model->PBRGAT_Given == FALSE) model->PBRGAT=4.0;
    if(model->CJORBOTD_Given == FALSE) model->CJORBOTD=1.0e-3;
    if(model->CJORSTID_Given == FALSE) model->CJORSTID=1.0e-9;
    if(model->CJORGATD_Given == FALSE) model->CJORGATD=1.0e-9;
    if(model->VBIRBOTD_Given == FALSE) model->VBIRBOTD=1.0;
    if(model->VBIRSTID_Given == FALSE) model->VBIRSTID=1.0;
    if(model->VBIRGATD_Given == FALSE) model->VBIRGATD=1.0;
    if(model->PBOTD_Given == FALSE) model->PBOTD=0.5;
    if(model->PSTID_Given == FALSE) model->PSTID=0.5;
    if(model->PGATD_Given == FALSE) model->PGATD=0.5;
    if(model->PHIGBOTD_Given == FALSE) model->PHIGBOTD=1.16;
    if(model->PHIGSTID_Given == FALSE) model->PHIGSTID=1.16;
    if(model->PHIGGATD_Given == FALSE) model->PHIGGATD=1.16;
    if(model->IDSATRBOTD_Given == FALSE) model->IDSATRBOTD=1.0e-12;
    if(model->IDSATRSTID_Given == FALSE) model->IDSATRSTID=1.0e-18;
    if(model->IDSATRGATD_Given == FALSE) model->IDSATRGATD=1.0e-18;
    if(model->CSRHBOTD_Given == FALSE) model->CSRHBOTD=1.0e2;
    if(model->CSRHSTID_Given == FALSE) model->CSRHSTID=1.0e-4;
    if(model->CSRHGATD_Given == FALSE) model->CSRHGATD=1.0e-4;
    if(model->XJUNSTID_Given == FALSE) model->XJUNSTID=1.0e-7;
    if(model->XJUNGATD_Given == FALSE) model->XJUNGATD=1.0e-7;
    if(model->CTATBOTD_Given == FALSE) model->CTATBOTD=1.0e2;
    if(model->CTATSTID_Given == FALSE) model->CTATSTID=1.0e-4;
    if(model->CTATGATD_Given == FALSE) model->CTATGATD=1.0e-4;
    if(model->MEFFTATBOTD_Given == FALSE) model->MEFFTATBOTD=0.25;
    if(model->MEFFTATSTID_Given == FALSE) model->MEFFTATSTID=0.25;
    if(model->MEFFTATGATD_Given == FALSE) model->MEFFTATGATD=0.25;
    if(model->CBBTBOTD_Given == FALSE) model->CBBTBOTD=1.0e-12;
    if(model->CBBTSTID_Given == FALSE) model->CBBTSTID=1.0e-18;
    if(model->CBBTGATD_Given == FALSE) model->CBBTGATD=1.0e-18;
    if(model->FBBTRBOTD_Given == FALSE) model->FBBTRBOTD=1.0e9;
    if(model->FBBTRSTID_Given == FALSE) model->FBBTRSTID=1.0e9;
    if(model->FBBTRGATD_Given == FALSE) model->FBBTRGATD=1.0e9;
    if(model->STFBBTBOTD_Given == FALSE) model->STFBBTBOTD=(-1.0e-3);
    if(model->STFBBTSTID_Given == FALSE) model->STFBBTSTID=(-1.0e-3);
    if(model->STFBBTGATD_Given == FALSE) model->STFBBTGATD=(-1.0e-3);
    if(model->VBRBOTD_Given == FALSE) model->VBRBOTD=10.0;
    if(model->VBRSTID_Given == FALSE) model->VBRSTID=10.0;
    if(model->VBRGATD_Given == FALSE) model->VBRGATD=10.0;
    if(model->PBRBOTD_Given == FALSE) model->PBRBOTD=4.0;
    if(model->PBRSTID_Given == FALSE) model->PBRSTID=4.0;
    if(model->PBRGATD_Given == FALSE) model->PBRGATD=4.0;
    if(model->SWJUNEXP_Given == FALSE) model->SWJUNEXP=0.0;
    if(model->VJUNREF_Given == FALSE) model->VJUNREF=2.5;
    if(model->FJUNQ_Given == FALSE) model->FJUNQ=0.03;
    if(model->VJUNREFD_Given == FALSE) model->VJUNREFD=2.5;
    if(model->FJUNQD_Given == FALSE) model->FJUNQD=0.03;
    for ( here = psp103instances(model) ;here != NULL ; here = psp103nextInstance(here) )
    {
    if(here->L_Given == FALSE) here->L=1.0e-5;
    if(here->W_Given == FALSE) here->W=1.0e-5;
    if(here->SA_Given == FALSE) here->SA=0.0;
    if(here->SB_Given == FALSE) here->SB=0.0;
    if(here->SD_Given == FALSE) here->SD=0.0;
    if(here->SCA_Given == FALSE) here->SCA=0.0;
    if(here->SCB_Given == FALSE) here->SCB=0.0;
    if(here->SCC_Given == FALSE) here->SCC=0.0;
    if(here->SC_Given == FALSE) here->SC=0.0;
    if(here->NF_Given == FALSE) here->NF=1.0;
    if(here->NGCON_Given == FALSE) here->NGCON=1.0;
    if(here->XGW_Given == FALSE) here->XGW=1.0e-7;
    if(here->NRS_Given == FALSE) here->NRS=0.0;
    if(here->NRD_Given == FALSE) here->NRD=0.0;
    if(here->JW_Given == FALSE) here->JW=1.0e-6;
    if(here->DELVTO_Given == FALSE) here->DELVTO=0.0;
    if(here->FACTUO_Given == FALSE) here->FACTUO=1.0;
    if(here->DELVTOEDGE_Given == FALSE) here->DELVTOEDGE=0.0;
    if(here->FACTUOEDGE_Given == FALSE) here->FACTUOEDGE=1.0;
    if(here->ABSOURCE_Given == FALSE) here->ABSOURCE=1.0e-12;
    if(here->LSSOURCE_Given == FALSE) here->LSSOURCE=1.0e-6;
    if(here->LGSOURCE_Given == FALSE) here->LGSOURCE=1.0e-6;
    if(here->ABDRAIN_Given == FALSE) here->ABDRAIN=1.0e-12;
    if(here->LSDRAIN_Given == FALSE) here->LSDRAIN=1.0e-6;
    if(here->LGDRAIN_Given == FALSE) here->LGDRAIN=1.0e-6;
    if(here->AS_Given == FALSE) here->AS=1.0e-12;
    if(here->PS_Given == FALSE) here->PS=1.0e-6;
    if(here->AD_Given == FALSE) here->AD=1.0e-12;
    if(here->PD_Given == FALSE) here->PD=1.0e-6;
    if(here->MULT_Given == FALSE) here->MULT=1.0;
    if(here->IFACTOR_Given == FALSE) here->IFACTOR=1.0;
    if(here->CFACTOR_Given == FALSE) here->CFACTOR=1.0;
      /* External Nodes, connected ? */
      here->DNode_connected = (here->DNode >= 0);
      here->GNode_connected = (here->GNode >= 0);
      here->SNode_connected = (here->SNode >= 0);
      here->BNode_connected = (here->BNode >= 0);
      /* Internal Nodes */
      {
        here->NOINode = -1;
        here->NOINode_mine = 0;
        here->GPNode = -1;
        here->GPNode_mine = 0;
        here->SINode = -1;
        here->SINode_mine = 0;
        here->DINode = -1;
        here->DINode_mine = 0;
        here->BPNode = -1;
        here->BPNode_mine = 0;
        here->BINode = -1;
        here->BINode_mine = 0;
        here->BSNode = -1;
        here->BSNode_mine = 0;
        here->BDNode = -1;
        here->BDNode_mine = 0;
      }
       ((GENinstance*)here)->GENstate = *states;
       *states += psp103numStates;
      /* set states */
      here->state_NOI_GND = *states; *states += 2;
      here->state_BP_SI = *states; *states += 2;
      here->state_BD_DI = *states; *states += 2;
      here->state_BS_SI = *states; *states += 2;
      here->state_GP_BP = *states; *states += 2;
      here->state_GP_DI = *states; *states += 2;
      here->state_GP_SI = *states; *states += 2;
      here->state_DI_SI = *states; *states += 2;
      /* set Sparse Matrix Pointers */
      here->PTR_J_DI_SI_required=0;
      here->PTR_J_DI_BP_required=0;
      here->PTR_J_BP_SI_required=0;
      here->PTR_J_BP_BP_required=0;
      here->PTR_J_DI_GP_required=0;
      here->PTR_J_BP_GP_required=0;
      here->PTR_J_DI_DI_required=0;
      here->PTR_J_BP_DI_required=0;
      here->PTR_J_SI_SI_required=0;
      here->PTR_J_SI_BP_required=0;
      here->PTR_J_SI_GP_required=0;
      here->PTR_J_SI_DI_required=0;
      here->PTR_J_GP_SI_required=0;
      here->PTR_J_GP_BP_required=0;
      here->PTR_J_GP_DI_required=0;
      here->PTR_J_GP_GP_required=0;
      here->PTR_J_BS_SI_required=0;
      here->PTR_J_BS_BS_required=0;
      here->PTR_J_SI_BS_required=0;
      here->PTR_J_BS_DI_required=0;
      here->PTR_J_BS_BD_required=0;
      here->PTR_J_SI_BD_required=0;
      here->PTR_J_BD_SI_required=0;
      here->PTR_J_BD_BS_required=0;
      here->PTR_J_DI_BS_required=0;
      here->PTR_J_BD_DI_required=0;
      here->PTR_J_BD_BD_required=0;
      here->PTR_J_DI_BD_required=0;
      here->PTR_J_G_G_required=0;
      here->PTR_J_G_GP_required=0;
      here->PTR_J_GP_G_required=0;
      here->PTR_J_S_S_required=0;
      here->PTR_J_S_SI_required=0;
      here->PTR_J_SI_S_required=0;
      here->PTR_J_D_D_required=0;
      here->PTR_J_D_DI_required=0;
      here->PTR_J_DI_D_required=0;
      here->PTR_J_BP_BI_required=0;
      here->PTR_J_BI_BP_required=0;
      here->PTR_J_BI_BI_required=0;
      here->PTR_J_BS_BI_required=0;
      here->PTR_J_BI_BS_required=0;
      here->PTR_J_BD_BI_required=0;
      here->PTR_J_BI_BD_required=0;
      here->PTR_J_B_B_required=0;
      here->PTR_J_B_BI_required=0;
      here->PTR_J_BI_B_required=0;
      here->PTR_J_NOI_SI_required=0;
      here->PTR_J_NOI_BP_required=0;
      here->PTR_J_NOI_GP_required=0;
      here->PTR_J_NOI_DI_required=0;
      here->PTR_J_NOI_NOI_required=0;
      here->PTR_J_BS_BP_required=0;
      here->PTR_J_BS_GP_required=0;
      here->PTR_J_BD_BP_required=0;
      here->PTR_J_BD_GP_required=0;

      psp103guesstopology(matrix,ckt,model,here);

      /* Internal Nodes */
      {
        int error;
        CKTnode *tmp;
        if(here->DNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XDX");
          if(error) return(error);
          here->DNode = tmp->number;
          here->DNode_mine = 1;
        }
        if(here->GNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XGX");
          if(error) return(error);
          here->GNode = tmp->number;
          here->GNode_mine = 1;
        }
        if(here->SNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XSX");
          if(error) return(error);
          here->SNode = tmp->number;
          here->SNode_mine = 1;
        }
        if(here->BNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XBX");
          if(error) return(error);
          here->BNode = tmp->number;
          here->BNode_mine = 1;
        }
        if(here->NOINode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XNOIX");
          if(error) return(error);
          here->NOINode = tmp->number;
          here->NOINode_mine = 1;
        }
        if(here->GPNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XGPX");
          if(error) return(error);
          here->GPNode = tmp->number;
          here->GPNode_mine = 1;
        }
        if(here->SINode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XSIX");
          if(error) return(error);
          here->SINode = tmp->number;
          here->SINode_mine = 1;
        }
        if(here->DINode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XDIX");
          if(error) return(error);
          here->DINode = tmp->number;
          here->DINode_mine = 1;
        }
        if(here->BPNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XBPX");
          if(error) return(error);
          here->BPNode = tmp->number;
          here->BPNode_mine = 1;
        }
        if(here->BINode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XBIX");
          if(error) return(error);
          here->BINode = tmp->number;
          here->BINode_mine = 1;
        }
        if(here->BSNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XBSX");
          if(error) return(error);
          here->BSNode = tmp->number;
          here->BSNode_mine = 1;
        }
        if(here->BDNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->psp103name,"XBDX");
          if(error) return(error);
          here->BDNode = tmp->number;
          here->BDNode_mine = 1;
        }
      }
        if(here->PTR_J_DI_SI_required==1)
        {
          here->PTR_J_DI_SI=SMPmakeElt(matrix,here->DINode,here->SINode);
        }
        if(here->PTR_J_DI_BP_required==1)
        {
          here->PTR_J_DI_BP=SMPmakeElt(matrix,here->DINode,here->BPNode);
        }
        if(here->PTR_J_BP_SI_required==1)
        {
          here->PTR_J_BP_SI=SMPmakeElt(matrix,here->BPNode,here->SINode);
        }
        if(here->PTR_J_BP_BP_required==1)
        {
          here->PTR_J_BP_BP=SMPmakeElt(matrix,here->BPNode,here->BPNode);
        }
        if(here->PTR_J_DI_GP_required==1)
        {
          here->PTR_J_DI_GP=SMPmakeElt(matrix,here->DINode,here->GPNode);
        }
        if(here->PTR_J_BP_GP_required==1)
        {
          here->PTR_J_BP_GP=SMPmakeElt(matrix,here->BPNode,here->GPNode);
        }
        if(here->PTR_J_DI_DI_required==1)
        {
          here->PTR_J_DI_DI=SMPmakeElt(matrix,here->DINode,here->DINode);
        }
        if(here->PTR_J_BP_DI_required==1)
        {
          here->PTR_J_BP_DI=SMPmakeElt(matrix,here->BPNode,here->DINode);
        }
        if(here->PTR_J_SI_SI_required==1)
        {
          here->PTR_J_SI_SI=SMPmakeElt(matrix,here->SINode,here->SINode);
        }
        if(here->PTR_J_SI_BP_required==1)
        {
          here->PTR_J_SI_BP=SMPmakeElt(matrix,here->SINode,here->BPNode);
        }
        if(here->PTR_J_SI_GP_required==1)
        {
          here->PTR_J_SI_GP=SMPmakeElt(matrix,here->SINode,here->GPNode);
        }
        if(here->PTR_J_SI_DI_required==1)
        {
          here->PTR_J_SI_DI=SMPmakeElt(matrix,here->SINode,here->DINode);
        }
        if(here->PTR_J_GP_SI_required==1)
        {
          here->PTR_J_GP_SI=SMPmakeElt(matrix,here->GPNode,here->SINode);
        }
        if(here->PTR_J_GP_BP_required==1)
        {
          here->PTR_J_GP_BP=SMPmakeElt(matrix,here->GPNode,here->BPNode);
        }
        if(here->PTR_J_GP_DI_required==1)
        {
          here->PTR_J_GP_DI=SMPmakeElt(matrix,here->GPNode,here->DINode);
        }
        if(here->PTR_J_GP_GP_required==1)
        {
          here->PTR_J_GP_GP=SMPmakeElt(matrix,here->GPNode,here->GPNode);
        }
        if(here->PTR_J_BS_SI_required==1)
        {
          here->PTR_J_BS_SI=SMPmakeElt(matrix,here->BSNode,here->SINode);
        }
        if(here->PTR_J_BS_BS_required==1)
        {
          here->PTR_J_BS_BS=SMPmakeElt(matrix,here->BSNode,here->BSNode);
        }
        if(here->PTR_J_SI_BS_required==1)
        {
          here->PTR_J_SI_BS=SMPmakeElt(matrix,here->SINode,here->BSNode);
        }
        if(here->PTR_J_BS_DI_required==1)
        {
          here->PTR_J_BS_DI=SMPmakeElt(matrix,here->BSNode,here->DINode);
        }
        if(here->PTR_J_BS_BD_required==1)
        {
          here->PTR_J_BS_BD=SMPmakeElt(matrix,here->BSNode,here->BDNode);
        }
        if(here->PTR_J_SI_BD_required==1)
        {
          here->PTR_J_SI_BD=SMPmakeElt(matrix,here->SINode,here->BDNode);
        }
        if(here->PTR_J_BD_SI_required==1)
        {
          here->PTR_J_BD_SI=SMPmakeElt(matrix,here->BDNode,here->SINode);
        }
        if(here->PTR_J_BD_BS_required==1)
        {
          here->PTR_J_BD_BS=SMPmakeElt(matrix,here->BDNode,here->BSNode);
        }
        if(here->PTR_J_DI_BS_required==1)
        {
          here->PTR_J_DI_BS=SMPmakeElt(matrix,here->DINode,here->BSNode);
        }
        if(here->PTR_J_BD_DI_required==1)
        {
          here->PTR_J_BD_DI=SMPmakeElt(matrix,here->BDNode,here->DINode);
        }
        if(here->PTR_J_BD_BD_required==1)
        {
          here->PTR_J_BD_BD=SMPmakeElt(matrix,here->BDNode,here->BDNode);
        }
        if(here->PTR_J_DI_BD_required==1)
        {
          here->PTR_J_DI_BD=SMPmakeElt(matrix,here->DINode,here->BDNode);
        }
        if(here->PTR_J_G_G_required==1)
        {
          here->PTR_J_G_G=SMPmakeElt(matrix,here->GNode,here->GNode);
        }
        if(here->PTR_J_G_GP_required==1)
        {
          here->PTR_J_G_GP=SMPmakeElt(matrix,here->GNode,here->GPNode);
        }
        if(here->PTR_J_GP_G_required==1)
        {
          here->PTR_J_GP_G=SMPmakeElt(matrix,here->GPNode,here->GNode);
        }
        if(here->PTR_J_S_S_required==1)
        {
          here->PTR_J_S_S=SMPmakeElt(matrix,here->SNode,here->SNode);
        }
        if(here->PTR_J_S_SI_required==1)
        {
          here->PTR_J_S_SI=SMPmakeElt(matrix,here->SNode,here->SINode);
        }
        if(here->PTR_J_SI_S_required==1)
        {
          here->PTR_J_SI_S=SMPmakeElt(matrix,here->SINode,here->SNode);
        }
        if(here->PTR_J_D_D_required==1)
        {
          here->PTR_J_D_D=SMPmakeElt(matrix,here->DNode,here->DNode);
        }
        if(here->PTR_J_D_DI_required==1)
        {
          here->PTR_J_D_DI=SMPmakeElt(matrix,here->DNode,here->DINode);
        }
        if(here->PTR_J_DI_D_required==1)
        {
          here->PTR_J_DI_D=SMPmakeElt(matrix,here->DINode,here->DNode);
        }
        if(here->PTR_J_BP_BI_required==1)
        {
          here->PTR_J_BP_BI=SMPmakeElt(matrix,here->BPNode,here->BINode);
        }
        if(here->PTR_J_BI_BP_required==1)
        {
          here->PTR_J_BI_BP=SMPmakeElt(matrix,here->BINode,here->BPNode);
        }
        if(here->PTR_J_BI_BI_required==1)
        {
          here->PTR_J_BI_BI=SMPmakeElt(matrix,here->BINode,here->BINode);
        }
        if(here->PTR_J_BS_BI_required==1)
        {
          here->PTR_J_BS_BI=SMPmakeElt(matrix,here->BSNode,here->BINode);
        }
        if(here->PTR_J_BI_BS_required==1)
        {
          here->PTR_J_BI_BS=SMPmakeElt(matrix,here->BINode,here->BSNode);
        }
        if(here->PTR_J_BD_BI_required==1)
        {
          here->PTR_J_BD_BI=SMPmakeElt(matrix,here->BDNode,here->BINode);
        }
        if(here->PTR_J_BI_BD_required==1)
        {
          here->PTR_J_BI_BD=SMPmakeElt(matrix,here->BINode,here->BDNode);
        }
        if(here->PTR_J_B_B_required==1)
        {
          here->PTR_J_B_B=SMPmakeElt(matrix,here->BNode,here->BNode);
        }
        if(here->PTR_J_B_BI_required==1)
        {
          here->PTR_J_B_BI=SMPmakeElt(matrix,here->BNode,here->BINode);
        }
        if(here->PTR_J_BI_B_required==1)
        {
          here->PTR_J_BI_B=SMPmakeElt(matrix,here->BINode,here->BNode);
        }
        if(here->PTR_J_NOI_SI_required==1)
        {
          here->PTR_J_NOI_SI=SMPmakeElt(matrix,here->NOINode,here->SINode);
        }
        if(here->PTR_J_NOI_BP_required==1)
        {
          here->PTR_J_NOI_BP=SMPmakeElt(matrix,here->NOINode,here->BPNode);
        }
        if(here->PTR_J_NOI_GP_required==1)
        {
          here->PTR_J_NOI_GP=SMPmakeElt(matrix,here->NOINode,here->GPNode);
        }
        if(here->PTR_J_NOI_DI_required==1)
        {
          here->PTR_J_NOI_DI=SMPmakeElt(matrix,here->NOINode,here->DINode);
        }
        if(here->PTR_J_NOI_NOI_required==1)
        {
          here->PTR_J_NOI_NOI=SMPmakeElt(matrix,here->NOINode,here->NOINode);
        }
        if(here->PTR_J_BS_BP_required==1)
        {
          here->PTR_J_BS_BP=SMPmakeElt(matrix,here->BSNode,here->BPNode);
        }
        if(here->PTR_J_BS_GP_required==1)
        {
          here->PTR_J_BS_GP=SMPmakeElt(matrix,here->BSNode,here->GPNode);
        }
        if(here->PTR_J_BD_BP_required==1)
        {
          here->PTR_J_BD_BP=SMPmakeElt(matrix,here->BDNode,here->BPNode);
        }
        if(here->PTR_J_BD_GP_required==1)
        {
          here->PTR_J_BD_GP=SMPmakeElt(matrix,here->BDNode,here->GPNode);
        }

    }
  }
  return(OK);
}


int
psp103unsetup(GENmodel *inModel, CKTcircuit *ckt)
{
  psp103model *model = (psp103model*)inModel;
  psp103instance *here;

  /*  loop through all the psp103 device models */
  for ( ;model != NULL ;model = psp103nextModel(model) )
  {
    for ( here = psp103instances(model) ;here != NULL ; here = psp103nextInstance(here) )
    {
        if (here->DNode_mine) {
            if (here->DNode > 0)
                CKTdltNNum(ckt, here->DNode);
            here->DNode_mine = 0;
        }
        if (!here->DNode_connected)
            here->DNode = -1;
        if (here->GNode_mine) {
            if (here->GNode > 0)
                CKTdltNNum(ckt, here->GNode);
            here->GNode_mine = 0;
        }
        if (!here->GNode_connected)
            here->GNode = -1;
        if (here->SNode_mine) {
            if (here->SNode > 0)
                CKTdltNNum(ckt, here->SNode);
            here->SNode_mine = 0;
        }
        if (!here->SNode_connected)
            here->SNode = -1;
        if (here->BNode_mine) {
            if (here->BNode > 0)
                CKTdltNNum(ckt, here->BNode);
            here->BNode_mine = 0;
        }
        if (!here->BNode_connected)
            here->BNode = -1;
        if (here->BDNode_mine)
            if (here->BDNode > 0)
                CKTdltNNum(ckt, here->BDNode);
        here->BDNode = -1;
        here->BDNode_mine = 0;
        if (here->BSNode_mine)
            if (here->BSNode > 0)
                CKTdltNNum(ckt, here->BSNode);
        here->BSNode = -1;
        here->BSNode_mine = 0;
        if (here->BINode_mine)
            if (here->BINode > 0)
                CKTdltNNum(ckt, here->BINode);
        here->BINode = -1;
        here->BINode_mine = 0;
        if (here->BPNode_mine)
            if (here->BPNode > 0)
                CKTdltNNum(ckt, here->BPNode);
        here->BPNode = -1;
        here->BPNode_mine = 0;
        if (here->DINode_mine)
            if (here->DINode > 0)
                CKTdltNNum(ckt, here->DINode);
        here->DINode = -1;
        here->DINode_mine = 0;
        if (here->SINode_mine)
            if (here->SINode > 0)
                CKTdltNNum(ckt, here->SINode);
        here->SINode = -1;
        here->SINode_mine = 0;
        if (here->GPNode_mine)
            if (here->GPNode > 0)
                CKTdltNNum(ckt, here->GPNode);
        here->GPNode = -1;
        here->GPNode_mine = 0;
        if (here->NOINode_mine)
            if (here->NOINode > 0)
                CKTdltNNum(ckt, here->NOINode);
        here->NOINode = -1;
        here->NOINode_mine = 0;
    }
  }
  return OK;
}
