/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "hicum0defs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

int hicum0setup (SMPmatrix *matrix, GENmodel *inModel, CKTcircuit *ckt, int *states)
     /* load the hicum0 device structure with those pointers needed later 
      * for fast matrix loading 
      */
{
  hicum0model *model = (hicum0model*)inModel;
  hicum0instance *here;
  
  /*  loop through all the hicum0 device models */
  for ( ;model != NULL ;model = hicum0nextModel(model) )
  {
    if(model->is_Given == FALSE) model->is=1.0e-16;
    if(model->it_mod_Given == FALSE) model->it_mod=0;
    if(model->mcf_Given == FALSE) model->mcf=1.00;
    if(model->mcr_Given == FALSE) model->mcr=1.00;
    if(model->vef_Given == FALSE) model->vef=1.0e6;
    if(model->ver_Given == FALSE) model->ver=1.0e6;
    if(model->aver_Given == FALSE) model->aver=0.0;
    if(model->iqf_Given == FALSE) model->iqf=1.0e6;
    if(model->fiqf_Given == FALSE) model->fiqf=0.0;
    if(model->iqr_Given == FALSE) model->iqr=1.0e6;
    if(model->iqfh_Given == FALSE) model->iqfh=1.0e6;
    if(model->tfh_Given == FALSE) model->tfh=0.0;
    if(model->ahq_Given == FALSE) model->ahq=0.0;
    if(model->ibes_Given == FALSE) model->ibes=1e-18;
    if(model->mbe_Given == FALSE) model->mbe=1.0;
    if(model->ires_Given == FALSE) model->ires=0.0;
    if(model->mre_Given == FALSE) model->mre=2.0;
    if(model->ibcs_Given == FALSE) model->ibcs=0.0;
    if(model->mbc_Given == FALSE) model->mbc=1.0;
    if(model->cje0_Given == FALSE) model->cje0=1.0e-20;
    if(model->vde_Given == FALSE) model->vde=0.9;
    if(model->ze_Given == FALSE) model->ze=0.5;
    if(model->aje_Given == FALSE) model->aje=2.5;
    if(model->vdedc_Given == FALSE) model->vdedc=0.9;
    if(model->zedc_Given == FALSE) model->zedc=0.5;
    if(model->ajedc_Given == FALSE) model->ajedc=2.5;
    if(model->t0_Given == FALSE) model->t0=0.0;
    if(model->dt0h_Given == FALSE) model->dt0h=0.0;
    if(model->tbvl_Given == FALSE) model->tbvl=0.0;
    if(model->tef0_Given == FALSE) model->tef0=0.0;
    if(model->gte_Given == FALSE) model->gte=1.0;
    if(model->thcs_Given == FALSE) model->thcs=0.0;
    if(model->ahc_Given == FALSE) model->ahc=0.1;
    if(model->tr_Given == FALSE) model->tr=0.0;
    if(model->rci0_Given == FALSE) model->rci0=150;
    if(model->vlim_Given == FALSE) model->vlim=0.5;
    if(model->vpt_Given == FALSE) model->vpt=100;
    if(model->vces_Given == FALSE) model->vces=0.1;
    if(model->cjci0_Given == FALSE) model->cjci0=1.0e-20;
    if(model->vdci_Given == FALSE) model->vdci=0.7;
    if(model->zci_Given == FALSE) model->zci=0.333;
    if(model->vptci_Given == FALSE) model->vptci=100;
    if(model->cjcx0_Given == FALSE) model->cjcx0=1.0e-20;
    if(model->vdcx_Given == FALSE) model->vdcx=0.7;
    if(model->zcx_Given == FALSE) model->zcx=0.333;
    if(model->vptcx_Given == FALSE) model->vptcx=100;
    if(model->fbc_Given == FALSE) model->fbc=1.0;
    if(model->rbi0_Given == FALSE) model->rbi0=0.0;
    if(model->vr0e_Given == FALSE) model->vr0e=2.5;
    if(model->vr0c_Given == FALSE) model->vr0c=1.0e6;
    if(model->fgeo_Given == FALSE) model->fgeo=0.656;
    if(model->rbx_Given == FALSE) model->rbx=0.0;
    if(model->rcx_Given == FALSE) model->rcx=0.0;
    if(model->re_Given == FALSE) model->re=0.0;
    if(model->itss_Given == FALSE) model->itss=0.0;
    if(model->msf_Given == FALSE) model->msf=1.0;
    if(model->iscs_Given == FALSE) model->iscs=0.0;
    if(model->msc_Given == FALSE) model->msc=1.0;
    if(model->cjs0_Given == FALSE) model->cjs0=1.0e-20;
    if(model->vds_Given == FALSE) model->vds=0.3;
    if(model->zs_Given == FALSE) model->zs=0.3;
    if(model->vpts_Given == FALSE) model->vpts=100;
    if(model->cbcpar_Given == FALSE) model->cbcpar=0.0;
    if(model->cbepar_Given == FALSE) model->cbepar=0.0;
    if(model->eavl_Given == FALSE) model->eavl=0.0;
    if(model->kavl_Given == FALSE) model->kavl=0.0;
    if(model->kf_Given == FALSE) model->kf=0.0;
    if(model->af_Given == FALSE) model->af=2.0;
    if(model->alqf_Given == FALSE) model->alqf=0.167;
    if(model->alit_Given == FALSE) model->alit=0.333;
    if(model->flnqs_Given == FALSE) model->flnqs=0;
    if(model->vgb_Given == FALSE) model->vgb=1.2;
    if(model->vge_Given == FALSE) model->vge=1.17;
    if(model->vgc_Given == FALSE) model->vgc=1.17;
    if(model->vgs_Given == FALSE) model->vgs=1.17;
    if(model->f1vg_Given == FALSE) model->f1vg=(-1.02377e-4);
    if(model->f2vg_Given == FALSE) model->f2vg=4.3215e-4;
    if(model->alt0_Given == FALSE) model->alt0=0.0;
    if(model->kt0_Given == FALSE) model->kt0=0.0;
    if(model->zetact_Given == FALSE) model->zetact=3.0;
    if(model->zetabet_Given == FALSE) model->zetabet=3.5;
    if(model->zetaci_Given == FALSE) model->zetaci=0.0;
    if(model->alvs_Given == FALSE) model->alvs=0.0;
    if(model->alces_Given == FALSE) model->alces=0.0;
    if(model->zetarbi_Given == FALSE) model->zetarbi=0.0;
    if(model->zetarbx_Given == FALSE) model->zetarbx=0.0;
    if(model->zetarcx_Given == FALSE) model->zetarcx=0.0;
    if(model->zetare_Given == FALSE) model->zetare=0.0;
    if(model->zetaiqf_Given == FALSE) model->zetaiqf=0.0;
    if(model->alkav_Given == FALSE) model->alkav=0.0;
    if(model->aleav_Given == FALSE) model->aleav=0.0;
    if(model->zetarth_Given == FALSE) model->zetarth=0.0;
    if(model->tef_temp_Given == FALSE) model->tef_temp=1;
    if(model->zetaver_Given == FALSE) model->zetaver=(-1.0);
    if(model->zetavgbe_Given == FALSE) model->zetavgbe=1.0;
    if(model->dvgbe_Given == FALSE) model->dvgbe=0.0;
    if(model->aliqfh_Given == FALSE) model->aliqfh=0.0;
    if(model->kiqfh_Given == FALSE) model->kiqfh=0.0;
    if(model->flsh_Given == FALSE) model->flsh=0;
    if(model->rth_Given == FALSE) model->rth=0.0;
    if(model->cth_Given == FALSE) model->cth=0.0;
    if(model->npn_Given == FALSE) model->npn=1;
    if(model->pnp_Given == FALSE) model->pnp=1;
    if(model->type_Given == FALSE) model->type=((model->npn==0)?((model->pnp==0)?0:1):((model->pnp==0)?(-1):0));
    if(model->tnom_Given == FALSE) model->tnom=27.0;
    for ( here = hicum0instances(model) ;here != NULL ; here = hicum0nextInstance(here) )
    {
    if(here->dtemp_Given == FALSE) here->dtemp=0.0;
      /* External Nodes, connected ? */
      here->cNode_connected = (here->cNode >= 0);
      here->bNode_connected = (here->bNode >= 0);
      here->eNode_connected = (here->eNode >= 0);
      here->sNode_connected = (here->sNode >= 0);
      here->tnodeNode_connected = (here->tnodeNode >= 0);
      /* Internal Nodes */
      {
        here->ciNode = -1;
        here->ciNode_mine = 0;
        here->biNode = -1;
        here->biNode_mine = 0;
        here->eiNode = -1;
        here->eiNode_mine = 0;
        here->xf1Node = -1;
        here->xf1Node_mine = 0;
        here->xf2Node = -1;
        here->xf2Node_mine = 0;
        here->xfNode = -1;
        here->xfNode_mine = 0;
      }
       ((GENinstance*)here)->GENstate = *states;
       *states += hicum0numStates;
      /* set states */
      here->state_xf_GND = *states; *states += 2;
      here->state_xf2_GND = *states; *states += 2;
      here->state_xf1_GND = *states; *states += 2;
      here->state_tnode_GND = *states; *states += 2;
      here->state_b_e = *states; *states += 2;
      here->state_b_ci = *states; *states += 2;
      here->state_s_ci = *states; *states += 2;
      here->state_bi_ci = *states; *states += 2;
      here->state_bi_ei = *states; *states += 2;
      /* set Sparse Matrix Pointers */
      here->PTR_J_bi_bi_required=0;
      here->PTR_J_bi_ei_required=0;
      here->PTR_J_ei_bi_required=0;
      here->PTR_J_ei_ei_required=0;
      here->PTR_J_bi_ci_required=0;
      here->PTR_J_ci_bi_required=0;
      here->PTR_J_ci_ci_required=0;
      here->PTR_J_ci_ei_required=0;
      here->PTR_J_ei_ci_required=0;
      here->PTR_J_b_s_required=0;
      here->PTR_J_b_ci_required=0;
      here->PTR_J_s_s_required=0;
      here->PTR_J_s_ci_required=0;
      here->PTR_J_b_b_required=0;
      here->PTR_J_s_b_required=0;
      here->PTR_J_b_tnode_required=0;
      here->PTR_J_s_tnode_required=0;
      here->PTR_J_s_bi_required=0;
      here->PTR_J_s_ei_required=0;
      here->PTR_J_ci_s_required=0;
      here->PTR_J_ci_tnode_required=0;
      here->PTR_J_ci_b_required=0;
      here->PTR_J_b_bi_required=0;
      here->PTR_J_b_e_required=0;
      here->PTR_J_e_b_required=0;
      here->PTR_J_e_e_required=0;
      here->PTR_J_ei_tnode_required=0;
      here->PTR_J_e_tnode_required=0;
      here->PTR_J_ei_e_required=0;
      here->PTR_J_e_ei_required=0;
      here->PTR_J_c_tnode_required=0;
      here->PTR_J_ci_c_required=0;
      here->PTR_J_c_ci_required=0;
      here->PTR_J_c_c_required=0;
      here->PTR_J_bi_b_required=0;
      here->PTR_J_b_ei_required=0;
      here->PTR_J_bi_tnode_required=0;
      here->PTR_J_bi_xf_required=0;
      here->PTR_J_ei_xf_required=0;
      here->PTR_J_ei_b_required=0;
      here->PTR_J_ci_xf2_required=0;
      here->PTR_J_ei_xf2_required=0;
      here->PTR_J_tnode_tnode_required=0;
      here->PTR_J_tnode_ci_required=0;
      here->PTR_J_tnode_ei_required=0;
      here->PTR_J_tnode_bi_required=0;
      here->PTR_J_tnode_b_required=0;
      here->PTR_J_tnode_s_required=0;
      here->PTR_J_tnode_e_required=0;
      here->PTR_J_tnode_c_required=0;
      here->PTR_J_xf1_ci_required=0;
      here->PTR_J_xf1_ei_required=0;
      here->PTR_J_xf1_bi_required=0;
      here->PTR_J_xf1_b_required=0;
      here->PTR_J_xf1_tnode_required=0;
      here->PTR_J_xf1_xf2_required=0;
      here->PTR_J_xf1_xf1_required=0;
      here->PTR_J_xf2_bi_required=0;
      here->PTR_J_xf2_ei_required=0;
      here->PTR_J_xf2_ci_required=0;
      here->PTR_J_xf2_b_required=0;
      here->PTR_J_xf2_tnode_required=0;
      here->PTR_J_xf2_xf1_required=0;
      here->PTR_J_xf2_xf2_required=0;
      here->PTR_J_xf_ci_required=0;
      here->PTR_J_xf_ei_required=0;
      here->PTR_J_xf_bi_required=0;
      here->PTR_J_xf_b_required=0;
      here->PTR_J_xf_tnode_required=0;
      here->PTR_J_xf_xf_required=0;

      hicum0guesstopology(matrix,ckt,model,here);

      /* Internal Nodes */
      {
        int error;
        CKTnode *tmp;
        if(here->cNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XcX");
          if(error) return(error);
          here->cNode = tmp->number;
          here->cNode_mine = 1;
        }
        if(here->bNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XbX");
          if(error) return(error);
          here->bNode = tmp->number;
          here->bNode_mine = 1;
        }
        if(here->eNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XeX");
          if(error) return(error);
          here->eNode = tmp->number;
          here->eNode_mine = 1;
        }
        if(here->sNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XsX");
          if(error) return(error);
          here->sNode = tmp->number;
          here->sNode_mine = 1;
        }
        if(here->tnodeNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XtnodeX");
          if(error) return(error);
          here->tnodeNode = tmp->number;
          here->tnodeNode_mine = 1;
        }
        if(here->ciNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XciX");
          if(error) return(error);
          here->ciNode = tmp->number;
          here->ciNode_mine = 1;
        }
        if(here->biNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XbiX");
          if(error) return(error);
          here->biNode = tmp->number;
          here->biNode_mine = 1;
        }
        if(here->eiNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XeiX");
          if(error) return(error);
          here->eiNode = tmp->number;
          here->eiNode_mine = 1;
        }
        if(here->xf1Node == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"Xxf1X");
          if(error) return(error);
          here->xf1Node = tmp->number;
          here->xf1Node_mine = 1;
        }
        if(here->xf2Node == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"Xxf2X");
          if(error) return(error);
          here->xf2Node = tmp->number;
          here->xf2Node_mine = 1;
        }
        if(here->xfNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->hicum0name,"XxfX");
          if(error) return(error);
          here->xfNode = tmp->number;
          here->xfNode_mine = 1;
        }
      }
        if(here->PTR_J_bi_bi_required==1)
        {
          here->PTR_J_bi_bi=SMPmakeElt(matrix,here->biNode,here->biNode);
        }
        if(here->PTR_J_bi_ei_required==1)
        {
          here->PTR_J_bi_ei=SMPmakeElt(matrix,here->biNode,here->eiNode);
        }
        if(here->PTR_J_ei_bi_required==1)
        {
          here->PTR_J_ei_bi=SMPmakeElt(matrix,here->eiNode,here->biNode);
        }
        if(here->PTR_J_ei_ei_required==1)
        {
          here->PTR_J_ei_ei=SMPmakeElt(matrix,here->eiNode,here->eiNode);
        }
        if(here->PTR_J_bi_ci_required==1)
        {
          here->PTR_J_bi_ci=SMPmakeElt(matrix,here->biNode,here->ciNode);
        }
        if(here->PTR_J_ci_bi_required==1)
        {
          here->PTR_J_ci_bi=SMPmakeElt(matrix,here->ciNode,here->biNode);
        }
        if(here->PTR_J_ci_ci_required==1)
        {
          here->PTR_J_ci_ci=SMPmakeElt(matrix,here->ciNode,here->ciNode);
        }
        if(here->PTR_J_ci_ei_required==1)
        {
          here->PTR_J_ci_ei=SMPmakeElt(matrix,here->ciNode,here->eiNode);
        }
        if(here->PTR_J_ei_ci_required==1)
        {
          here->PTR_J_ei_ci=SMPmakeElt(matrix,here->eiNode,here->ciNode);
        }
        if(here->PTR_J_b_s_required==1)
        {
          here->PTR_J_b_s=SMPmakeElt(matrix,here->bNode,here->sNode);
        }
        if(here->PTR_J_b_ci_required==1)
        {
          here->PTR_J_b_ci=SMPmakeElt(matrix,here->bNode,here->ciNode);
        }
        if(here->PTR_J_s_s_required==1)
        {
          here->PTR_J_s_s=SMPmakeElt(matrix,here->sNode,here->sNode);
        }
        if(here->PTR_J_s_ci_required==1)
        {
          here->PTR_J_s_ci=SMPmakeElt(matrix,here->sNode,here->ciNode);
        }
        if(here->PTR_J_b_b_required==1)
        {
          here->PTR_J_b_b=SMPmakeElt(matrix,here->bNode,here->bNode);
        }
        if(here->PTR_J_s_b_required==1)
        {
          here->PTR_J_s_b=SMPmakeElt(matrix,here->sNode,here->bNode);
        }
        if(here->PTR_J_b_tnode_required==1)
        {
          here->PTR_J_b_tnode=SMPmakeElt(matrix,here->bNode,here->tnodeNode);
        }
        if(here->PTR_J_s_tnode_required==1)
        {
          here->PTR_J_s_tnode=SMPmakeElt(matrix,here->sNode,here->tnodeNode);
        }
        if(here->PTR_J_s_bi_required==1)
        {
          here->PTR_J_s_bi=SMPmakeElt(matrix,here->sNode,here->biNode);
        }
        if(here->PTR_J_s_ei_required==1)
        {
          here->PTR_J_s_ei=SMPmakeElt(matrix,here->sNode,here->eiNode);
        }
        if(here->PTR_J_ci_s_required==1)
        {
          here->PTR_J_ci_s=SMPmakeElt(matrix,here->ciNode,here->sNode);
        }
        if(here->PTR_J_ci_tnode_required==1)
        {
          here->PTR_J_ci_tnode=SMPmakeElt(matrix,here->ciNode,here->tnodeNode);
        }
        if(here->PTR_J_ci_b_required==1)
        {
          here->PTR_J_ci_b=SMPmakeElt(matrix,here->ciNode,here->bNode);
        }
        if(here->PTR_J_b_bi_required==1)
        {
          here->PTR_J_b_bi=SMPmakeElt(matrix,here->bNode,here->biNode);
        }
        if(here->PTR_J_b_e_required==1)
        {
          here->PTR_J_b_e=SMPmakeElt(matrix,here->bNode,here->eNode);
        }
        if(here->PTR_J_e_b_required==1)
        {
          here->PTR_J_e_b=SMPmakeElt(matrix,here->eNode,here->bNode);
        }
        if(here->PTR_J_e_e_required==1)
        {
          here->PTR_J_e_e=SMPmakeElt(matrix,here->eNode,here->eNode);
        }
        if(here->PTR_J_ei_tnode_required==1)
        {
          here->PTR_J_ei_tnode=SMPmakeElt(matrix,here->eiNode,here->tnodeNode);
        }
        if(here->PTR_J_e_tnode_required==1)
        {
          here->PTR_J_e_tnode=SMPmakeElt(matrix,here->eNode,here->tnodeNode);
        }
        if(here->PTR_J_ei_e_required==1)
        {
          here->PTR_J_ei_e=SMPmakeElt(matrix,here->eiNode,here->eNode);
        }
        if(here->PTR_J_e_ei_required==1)
        {
          here->PTR_J_e_ei=SMPmakeElt(matrix,here->eNode,here->eiNode);
        }
        if(here->PTR_J_c_tnode_required==1)
        {
          here->PTR_J_c_tnode=SMPmakeElt(matrix,here->cNode,here->tnodeNode);
        }
        if(here->PTR_J_ci_c_required==1)
        {
          here->PTR_J_ci_c=SMPmakeElt(matrix,here->ciNode,here->cNode);
        }
        if(here->PTR_J_c_ci_required==1)
        {
          here->PTR_J_c_ci=SMPmakeElt(matrix,here->cNode,here->ciNode);
        }
        if(here->PTR_J_c_c_required==1)
        {
          here->PTR_J_c_c=SMPmakeElt(matrix,here->cNode,here->cNode);
        }
        if(here->PTR_J_bi_b_required==1)
        {
          here->PTR_J_bi_b=SMPmakeElt(matrix,here->biNode,here->bNode);
        }
        if(here->PTR_J_b_ei_required==1)
        {
          here->PTR_J_b_ei=SMPmakeElt(matrix,here->bNode,here->eiNode);
        }
        if(here->PTR_J_bi_tnode_required==1)
        {
          here->PTR_J_bi_tnode=SMPmakeElt(matrix,here->biNode,here->tnodeNode);
        }
        if(here->PTR_J_bi_xf_required==1)
        {
          here->PTR_J_bi_xf=SMPmakeElt(matrix,here->biNode,here->xfNode);
        }
        if(here->PTR_J_ei_xf_required==1)
        {
          here->PTR_J_ei_xf=SMPmakeElt(matrix,here->eiNode,here->xfNode);
        }
        if(here->PTR_J_ei_b_required==1)
        {
          here->PTR_J_ei_b=SMPmakeElt(matrix,here->eiNode,here->bNode);
        }
        if(here->PTR_J_ci_xf2_required==1)
        {
          here->PTR_J_ci_xf2=SMPmakeElt(matrix,here->ciNode,here->xf2Node);
        }
        if(here->PTR_J_ei_xf2_required==1)
        {
          here->PTR_J_ei_xf2=SMPmakeElt(matrix,here->eiNode,here->xf2Node);
        }
        if(here->PTR_J_tnode_tnode_required==1)
        {
          here->PTR_J_tnode_tnode=SMPmakeElt(matrix,here->tnodeNode,here->tnodeNode);
        }
        if(here->PTR_J_tnode_ci_required==1)
        {
          here->PTR_J_tnode_ci=SMPmakeElt(matrix,here->tnodeNode,here->ciNode);
        }
        if(here->PTR_J_tnode_ei_required==1)
        {
          here->PTR_J_tnode_ei=SMPmakeElt(matrix,here->tnodeNode,here->eiNode);
        }
        if(here->PTR_J_tnode_bi_required==1)
        {
          here->PTR_J_tnode_bi=SMPmakeElt(matrix,here->tnodeNode,here->biNode);
        }
        if(here->PTR_J_tnode_b_required==1)
        {
          here->PTR_J_tnode_b=SMPmakeElt(matrix,here->tnodeNode,here->bNode);
        }
        if(here->PTR_J_tnode_s_required==1)
        {
          here->PTR_J_tnode_s=SMPmakeElt(matrix,here->tnodeNode,here->sNode);
        }
        if(here->PTR_J_tnode_e_required==1)
        {
          here->PTR_J_tnode_e=SMPmakeElt(matrix,here->tnodeNode,here->eNode);
        }
        if(here->PTR_J_tnode_c_required==1)
        {
          here->PTR_J_tnode_c=SMPmakeElt(matrix,here->tnodeNode,here->cNode);
        }
        if(here->PTR_J_xf1_ci_required==1)
        {
          here->PTR_J_xf1_ci=SMPmakeElt(matrix,here->xf1Node,here->ciNode);
        }
        if(here->PTR_J_xf1_ei_required==1)
        {
          here->PTR_J_xf1_ei=SMPmakeElt(matrix,here->xf1Node,here->eiNode);
        }
        if(here->PTR_J_xf1_bi_required==1)
        {
          here->PTR_J_xf1_bi=SMPmakeElt(matrix,here->xf1Node,here->biNode);
        }
        if(here->PTR_J_xf1_b_required==1)
        {
          here->PTR_J_xf1_b=SMPmakeElt(matrix,here->xf1Node,here->bNode);
        }
        if(here->PTR_J_xf1_tnode_required==1)
        {
          here->PTR_J_xf1_tnode=SMPmakeElt(matrix,here->xf1Node,here->tnodeNode);
        }
        if(here->PTR_J_xf1_xf2_required==1)
        {
          here->PTR_J_xf1_xf2=SMPmakeElt(matrix,here->xf1Node,here->xf2Node);
        }
        if(here->PTR_J_xf1_xf1_required==1)
        {
          here->PTR_J_xf1_xf1=SMPmakeElt(matrix,here->xf1Node,here->xf1Node);
        }
        if(here->PTR_J_xf2_bi_required==1)
        {
          here->PTR_J_xf2_bi=SMPmakeElt(matrix,here->xf2Node,here->biNode);
        }
        if(here->PTR_J_xf2_ei_required==1)
        {
          here->PTR_J_xf2_ei=SMPmakeElt(matrix,here->xf2Node,here->eiNode);
        }
        if(here->PTR_J_xf2_ci_required==1)
        {
          here->PTR_J_xf2_ci=SMPmakeElt(matrix,here->xf2Node,here->ciNode);
        }
        if(here->PTR_J_xf2_b_required==1)
        {
          here->PTR_J_xf2_b=SMPmakeElt(matrix,here->xf2Node,here->bNode);
        }
        if(here->PTR_J_xf2_tnode_required==1)
        {
          here->PTR_J_xf2_tnode=SMPmakeElt(matrix,here->xf2Node,here->tnodeNode);
        }
        if(here->PTR_J_xf2_xf1_required==1)
        {
          here->PTR_J_xf2_xf1=SMPmakeElt(matrix,here->xf2Node,here->xf1Node);
        }
        if(here->PTR_J_xf2_xf2_required==1)
        {
          here->PTR_J_xf2_xf2=SMPmakeElt(matrix,here->xf2Node,here->xf2Node);
        }
        if(here->PTR_J_xf_ci_required==1)
        {
          here->PTR_J_xf_ci=SMPmakeElt(matrix,here->xfNode,here->ciNode);
        }
        if(here->PTR_J_xf_ei_required==1)
        {
          here->PTR_J_xf_ei=SMPmakeElt(matrix,here->xfNode,here->eiNode);
        }
        if(here->PTR_J_xf_bi_required==1)
        {
          here->PTR_J_xf_bi=SMPmakeElt(matrix,here->xfNode,here->biNode);
        }
        if(here->PTR_J_xf_b_required==1)
        {
          here->PTR_J_xf_b=SMPmakeElt(matrix,here->xfNode,here->bNode);
        }
        if(here->PTR_J_xf_tnode_required==1)
        {
          here->PTR_J_xf_tnode=SMPmakeElt(matrix,here->xfNode,here->tnodeNode);
        }
        if(here->PTR_J_xf_xf_required==1)
        {
          here->PTR_J_xf_xf=SMPmakeElt(matrix,here->xfNode,here->xfNode);
        }

    }
  }
  return(OK);
}


int
hicum0unsetup(GENmodel *inModel, CKTcircuit *ckt)
{
  hicum0model *model = (hicum0model*)inModel;
  hicum0instance *here;

  /*  loop through all the hicum0 device models */
  for ( ;model != NULL ;model = hicum0nextModel(model) )
  {
    for ( here = hicum0instances(model) ;here != NULL ; here = hicum0nextInstance(here) )
    {
        if (here->cNode_mine) {
            if (here->cNode > 0)
                CKTdltNNum(ckt, here->cNode);
            here->cNode_mine = 0;
        }
        if (!here->cNode_connected)
            here->cNode = -1;
        if (here->bNode_mine) {
            if (here->bNode > 0)
                CKTdltNNum(ckt, here->bNode);
            here->bNode_mine = 0;
        }
        if (!here->bNode_connected)
            here->bNode = -1;
        if (here->eNode_mine) {
            if (here->eNode > 0)
                CKTdltNNum(ckt, here->eNode);
            here->eNode_mine = 0;
        }
        if (!here->eNode_connected)
            here->eNode = -1;
        if (here->sNode_mine) {
            if (here->sNode > 0)
                CKTdltNNum(ckt, here->sNode);
            here->sNode_mine = 0;
        }
        if (!here->sNode_connected)
            here->sNode = -1;
        if (here->tnodeNode_mine) {
            if (here->tnodeNode > 0)
                CKTdltNNum(ckt, here->tnodeNode);
            here->tnodeNode_mine = 0;
        }
        if (!here->tnodeNode_connected)
            here->tnodeNode = -1;
        if (here->xfNode_mine)
            if (here->xfNode > 0)
                CKTdltNNum(ckt, here->xfNode);
        here->xfNode = -1;
        here->xfNode_mine = 0;
        if (here->xf2Node_mine)
            if (here->xf2Node > 0)
                CKTdltNNum(ckt, here->xf2Node);
        here->xf2Node = -1;
        here->xf2Node_mine = 0;
        if (here->xf1Node_mine)
            if (here->xf1Node > 0)
                CKTdltNNum(ckt, here->xf1Node);
        here->xf1Node = -1;
        here->xf1Node_mine = 0;
        if (here->eiNode_mine)
            if (here->eiNode > 0)
                CKTdltNNum(ckt, here->eiNode);
        here->eiNode = -1;
        here->eiNode_mine = 0;
        if (here->biNode_mine)
            if (here->biNode > 0)
                CKTdltNNum(ckt, here->biNode);
        here->biNode = -1;
        here->biNode_mine = 0;
        if (here->ciNode_mine)
            if (here->ciNode > 0)
                CKTdltNNum(ckt, here->ciNode);
        here->ciNode = -1;
        here->ciNode_mine = 0;
    }
  }
  return OK;
}
